from graph_ASG_ERmetaMetaModel import *
from stickylink import *
from widthXfillXdecoration import *
from ASG_Buttons import *
from ASG_Buttons import *
from ButtonConfig import *
from ATOM3Integer import *
from ATOM3Appearance import *
from ATOM3Float import *
from ATOM3Link import *
from ATOM3Boolean import *
from ATOM3List import *
from ATOM3Enum import *
from ATOM3Attribute import *
from ATOM3Constraint import *
from ATOM3String import *
from ATOM3BottomType import *

def PetriNets(self, rootNode):
    rootNode.Formalism_Name.setValue('Petri Nets')
    rootNode.Formalism_File.setValue('PNModels/PetriNets_MM.py')
    rootNode.RowSize.setValue(1)

    self.globalPrecondition( rootNode )

    self.obj73=ButtonConfig(self)

    self.obj73.Contents.Text.setValue('Place')
    self.obj73.Contents.Image.setValue('PNModels/Place.gif')
    self.obj73.Contents.lastSelected= "Image"
    self.obj73.Action.setValue(('ActionButton1', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# This method has as parameters:\n#   - wherex : X Position in window coordinates where the user clicked.\n#   - wherey : Y Position in window coordinates where the user clicked.\nnewPlace = self.createNewPNPlace (self, wherex, wherey)\n'))
    self.obj73.Drawing_Mode.setValue((' ', 1))
    self.obj73.Drawing_Mode.config = 0
    self.obj73.graphClass_= graph_ButtonConfig
    if self.genGraphics:
       from graph_ButtonConfig import *
       new_obj = graph_ButtonConfig(17.0,10.0,self.obj73)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("ButtonConfig", new_obj.tag)
    else: new_obj = None
    self.obj73.graphObject_ = new_obj
    rootNode.addNode(self.obj73)
    self.globalAndLocalPostcondition(self.obj73, rootNode)

    self.globalPrecondition( rootNode )

    self.obj74=ButtonConfig(self)

    self.obj74.Contents.Text.setValue('PNModels/Transition')
    self.obj74.Contents.Image.setValue('PNModels/Transition.gif')
    self.obj74.Contents.lastSelected= "Image"
    self.obj74.Action.setValue(('ActionButton1', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# This method has as parameters:\n#   - wherex : X Position in window coordinates where the user clicked.\n#   - wherey : Y Position in window coordinates where the user clicked.\nnewPlace = self.createNewPNTransition (self, wherex, wherey)\n'))
    self.obj74.Drawing_Mode.setValue((' ', 1))
    self.obj74.Drawing_Mode.config = 0
    self.obj74.graphClass_= graph_ButtonConfig
    if self.genGraphics:
       from graph_ButtonConfig import *
       new_obj = graph_ButtonConfig(191.0,11.0,self.obj74)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("ButtonConfig", new_obj.tag)
    else: new_obj = None
    self.obj74.graphObject_ = new_obj
    rootNode.addNode(self.obj74)
    self.globalAndLocalPostcondition(self.obj74, rootNode)

    self.globalPrecondition( rootNode )

    self.obj75=ButtonConfig(self)

    self.obj75.Contents.Text.setValue('Gen PNS code')
    self.obj75.Contents.Image.setValue('PNModels/genPNS.gif')
    self.obj75.Contents.lastSelected= "Image"
    self.obj75.Action.setValue(('Action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# The parameters of this method are:\n#   - wherex\n#   - wherey\nfrom GenCode4xpns import GenCode4xpns\nfrom GraphRewritingSys import GraphRewritingSys\nprint "self = ", self, "self.ASGroot=", self.ASGroot\nself.grs = GraphRewritingSys(self, [GenCode4xpns(self)], self.ASGroot)\nself.grs.evaluate(0, 0, self.grs.SEQ_RANDOM)\n\n\n\n'))
    self.obj75.Drawing_Mode.setValue((' ', 0))
    self.obj75.Drawing_Mode.config = 0
    self.obj75.graphClass_= graph_ButtonConfig
    if self.genGraphics:
       from graph_ButtonConfig import *
       new_obj = graph_ButtonConfig(18.0,69.0,self.obj75)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("ButtonConfig", new_obj.tag)
    else: new_obj = None
    self.obj75.graphObject_ = new_obj
    rootNode.addNode(self.obj75)
    self.globalAndLocalPostcondition(self.obj75, rootNode)

    self.globalPrecondition( rootNode )

    self.obj76=ButtonConfig(self)

    self.obj76.Contents.Text.setValue('Simulate')
    self.obj76.Contents.Image.setValue('PNModels/Simulate.gif')
    self.obj76.Contents.lastSelected= "Image"
    self.obj76.Action.setValue(('Action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# The parameters of this method are:\n#   - wherex\n#   - wherey\nfrom PNSimulator import PNSimulator\nfrom GraphRewritingSys import GraphRewritingSys\nprint "self = ", self, "self.ASGroot=", self.ASGroot\nself.grs = GraphRewritingSys(self, [PNSimulator(self)], self.ASGroot)\nself.grs.evaluate(1, 0, self.grs.SEQ_MANUAL,1, 0)\n\n\n\n\n\n\n'))
    self.obj76.Drawing_Mode.setValue((' ', 0))
    self.obj76.Drawing_Mode.config = 0
    self.obj76.graphClass_= graph_ButtonConfig
    if self.genGraphics:
       from graph_ButtonConfig import *
       new_obj = graph_ButtonConfig(191.0,67.0,self.obj76)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("ButtonConfig", new_obj.tag)
    else: new_obj = None
    self.obj76.graphObject_ = new_obj
    rootNode.addNode(self.obj76)
    self.globalAndLocalPostcondition(self.obj76, rootNode)

    self.globalPrecondition( rootNode )

    self.obj77=ButtonConfig(self)

    self.obj77.Contents.Text.setValue('')
    self.obj77.Contents.Image.setValue('PNModels/Animate.gif')
    self.obj77.Contents.lastSelected= "Image"
    self.obj77.Action.setValue(('Action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# The parameters of this method are:\n#   - wherex\n#   - wherey\n# The parameters of this method are:\n#   - wherex\n#   - wherey\nfrom PNSimulatorAnimator import PNSimulatorAnimator\nfrom GraphRewritingSys import GraphRewritingSys\nprint "self = ", self, "self.ASGroot=", self.ASGroot\nself.grs = GraphRewritingSys(self, [PNSimulatorAnimator(self)], self.ASGroot)\nself.grs.evaluate(0, 0, self.grs.SEQ_RANDOM, 1, 1)\n\n\n\n\n'))
    self.obj77.Drawing_Mode.setValue((' ', 0))
    self.obj77.Drawing_Mode.config = 0
    self.obj77.graphClass_= graph_ButtonConfig
    if self.genGraphics:
       from graph_ButtonConfig import *
       new_obj = graph_ButtonConfig(16.0,129.0,self.obj77)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("ButtonConfig", new_obj.tag)
    else: new_obj = None
    self.obj77.graphObject_ = new_obj
    rootNode.addNode(self.obj77)
    self.globalAndLocalPostcondition(self.obj77, rootNode)

    self.globalPrecondition( rootNode )

    self.obj78=ButtonConfig(self)

    self.obj78.Contents.Text.setValue('')
    self.obj78.Contents.Image.setValue('PNModels/CovTree.gif')
    self.obj78.Contents.lastSelected= "Image"
    self.obj78.Action.setValue(('Action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# The parameters of this method are:\n#   - wherex\n#   - wherey\nfrom PNlink import *\nfrom ATOM3TypeDialog import ATOM3TypeDialog\nfrom ASG_ReachGraph import ASG_ReachGraph\n\nres = ASG_ReachGraph(self)\n# Open a new modal window ATOM3 with the CTL meta-model\nwindowAtom3=ATOM3TypeDialog(self, res, ATOM3TypeDialog.OPEN, (None,OpenReachGraph))\nif windowAtom3.result_ok: print res.listNodes\n\n\n\n\n\n\n\n\n\n'))
    self.obj78.Drawing_Mode.setValue((' ', 0))
    self.obj78.Drawing_Mode.config = 0
    self.obj78.graphClass_= graph_ButtonConfig
    if self.genGraphics:
       from graph_ButtonConfig import *
       new_obj = graph_ButtonConfig(192.0,130.0,self.obj78)
       new_obj.DrawObject(self.UMLmodel)
       self.UMLmodel.addtag_withtag("ButtonConfig", new_obj.tag)
    else: new_obj = None
    self.obj78.graphObject_ = new_obj
    rootNode.addNode(self.obj78)
    self.globalAndLocalPostcondition(self.obj78, rootNode)
    self.drawConnections( )

newfunction = PetriNets

loadedMMName = 'Buttons'
