# _ Capacity2PNPlaceLinks.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from RoadSection import *
from ASG_Traffic import *
from Capacity import *
from GenericGraphNode import *
from ASG_PetriNets import *
from Source2Section import *
from tran2pl import *
from CapacityOf import *
from FlowTo import *
from PNPlace import *
from Source import *
from Sink import *
from ASG_GenericGraph import *
from Section2Sink import *
from pl2tran import *
from GenericGraphEdge import *
from PNTransition import *
class Capacity2PNPlaceLinks (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 4)
      self.TimeDelay = ATOM3Integer(2)
      self.exactMatch = 1
      self.LHS = ASG_Traffic(parent)
      self.LHS.merge(ASG_PetriNets(parent))
      self.LHS.merge(ASG_GenericGraph(parent))

      self.obj147=RoadSection(parent)

      self.obj147.num_vehicles.setNone()
      self.obj147.name.setValue('')
      self.obj147.GGLabel.setValue(4)
      self.obj147.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(120.0,48.0,self.obj147)
      else: new_obj = None
      self.obj147.graphObject_ = new_obj
      self.LHS.addNode(self.obj147)

      self.obj148=Capacity(parent)

      self.obj148.capacity.setNone()
      self.obj148.name.setValue('')
      self.obj148.GGLabel.setValue(1)
      self.obj148.graphClass_= graph_Capacity
      if parent.genGraphics:
         from graph_Capacity import *
         new_obj = graph_Capacity(100.0,149.0,self.obj148)
      else: new_obj = None
      self.obj148.graphObject_ = new_obj
      self.LHS.addNode(self.obj148)

      self.obj149=CapacityOf(parent)

      self.obj149.GGLabel.setValue(5)
      self.obj149.graphClass_= graph_CapacityOf
      if parent.genGraphics:
         from graph_CapacityOf import *
         new_obj = graph_CapacityOf(133.0,111.5,self.obj149)
      else: new_obj = None
      self.obj149.graphObject_ = new_obj
      self.LHS.addNode(self.obj149)

      self.obj150=PNPlace(parent)

      self.obj150.tokens.setNone()
      self.obj150.name.setValue('')
      self.obj150.GGLabel.setValue(2)
      self.obj150.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(282.0,143.0,self.obj150)
      else: new_obj = None
      self.obj150.graphObject_ = new_obj
      self.LHS.addNode(self.obj150)

      self.obj151=GenericGraphEdge(parent)

      self.obj151.GGLabel.setValue(3)
      self.obj151.graphClass_= graph_GenericGraphEdge
      if parent.genGraphics:
         from graph_GenericGraphEdge import *
         new_obj = graph_GenericGraphEdge(221.0,160.0,self.obj151)
      else: new_obj = None
      self.obj151.graphObject_ = new_obj
      self.LHS.addNode(self.obj151)
      self.obj148.out_connections_.append(self.obj149)
      self.obj149.in_connections_.append(self.obj148)
      self.obj148.graphObject_.pendingConnections.append((self.obj148.graphObject_.tag, self.obj149.graphObject_.tag, [132.99999999999997, 160.0, 133.0, 111.49999999999997], 2, 0))
      self.obj149.out_connections_.append(self.obj147)
      self.obj147.in_connections_.append(self.obj149)
      self.obj149.graphObject_.pendingConnections.append((self.obj149.graphObject_.tag, self.obj147.graphObject_.tag, [160.0, 60.999999999999986, 133.0, 111.49999999999997], 2, 0))
      self.obj150.out_connections_.append(self.obj151)
      self.obj151.in_connections_.append(self.obj150)
      self.obj150.graphObject_.pendingConnections.append((self.obj150.graphObject_.tag, self.obj151.graphObject_.tag, [290.0, 160.0, 220.99999999999994, 160.0], 2, 0))
      self.obj151.out_connections_.append(self.obj148)
      self.obj148.in_connections_.append(self.obj151)
      self.obj151.graphObject_.pendingConnections.append((self.obj151.graphObject_.tag, self.obj148.graphObject_.tag, [132.99999999999997, 160.0, 220.99999999999994, 160.0], 2, 0))
      self.RHS = ASG_Traffic(parent)
      self.RHS.merge(ASG_PetriNets(parent))
      self.RHS.merge(ASG_GenericGraph(parent))

      self.obj155=RoadSection(parent)

      self.obj155.num_vehicles.setValue(0)
      self.obj155.name.setValue('')
      self.obj155.GGLabel.setValue(4)
      self.obj155.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(180.0,100.0,self.obj155)
      else: new_obj = None
      self.obj155.graphObject_ = new_obj
      self.obj1550= AttrCalc()
      self.obj1550.Copy=ATOM3Boolean()
      self.obj1550.Copy.setValue(('Copy from LHS', 1))
      self.obj1550.Copy.config = 0
      self.obj1550.Specify=ATOM3Constraint()
      self.obj1550.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj155.GGset2Any['num_vehicles']= self.obj1550
      self.obj1551= AttrCalc()
      self.obj1551.Copy=ATOM3Boolean()
      self.obj1551.Copy.setValue(('Copy from LHS', 1))
      self.obj1551.Copy.config = 0
      self.obj1551.Specify=ATOM3Constraint()
      self.obj1551.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj155.GGset2Any['name']= self.obj1551
      self.RHS.addNode(self.obj155)

      self.obj156=Capacity(parent)

      self.obj156.capacity.setValue(0)
      self.obj156.name.setValue('')
      self.obj156.GGLabel.setValue(1)
      self.obj156.graphClass_= graph_Capacity
      if parent.genGraphics:
         from graph_Capacity import *
         new_obj = graph_Capacity(185.0,203.0,self.obj156)
      else: new_obj = None
      self.obj156.graphObject_ = new_obj
      self.obj1560= AttrCalc()
      self.obj1560.Copy=ATOM3Boolean()
      self.obj1560.Copy.setValue(('Copy from LHS', 1))
      self.obj1560.Copy.config = 0
      self.obj1560.Specify=ATOM3Constraint()
      self.obj1560.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj156.GGset2Any['capacity']= self.obj1560
      self.obj1561= AttrCalc()
      self.obj1561.Copy=ATOM3Boolean()
      self.obj1561.Copy.setValue(('Copy from LHS', 1))
      self.obj1561.Copy.config = 0
      self.obj1561.Specify=ATOM3Constraint()
      self.obj1561.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj156.GGset2Any['name']= self.obj1561
      self.RHS.addNode(self.obj156)

      self.obj157=CapacityOf(parent)

      self.obj157.GGLabel.setValue(6)
      self.obj157.graphClass_= graph_CapacityOf
      if parent.genGraphics:
         from graph_CapacityOf import *
         new_obj = graph_CapacityOf(340.0,113.0,self.obj157)
      else: new_obj = None
      self.obj157.graphObject_ = new_obj
      self.RHS.addNode(self.obj157)

      self.obj158=PNPlace(parent)

      self.obj158.tokens.setValue(0)
      self.obj158.name.setValue('0')
      self.obj158.GGLabel.setValue(2)
      self.obj158.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(358.0,197.0,self.obj158)
      else: new_obj = None
      self.obj158.graphObject_ = new_obj
      self.obj1580= AttrCalc()
      self.obj1580.Copy=ATOM3Boolean()
      self.obj1580.Copy.setValue(('Copy from LHS', 1))
      self.obj1580.Copy.config = 0
      self.obj1580.Specify=ATOM3Constraint()
      self.obj1580.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj158.GGset2Any['tokens']= self.obj1580
      self.obj1581= AttrCalc()
      self.obj1581.Copy=ATOM3Boolean()
      self.obj1581.Copy.setValue(('Copy from LHS', 1))
      self.obj1581.Copy.config = 0
      self.obj1581.Specify=ATOM3Constraint()
      self.obj1581.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj158.GGset2Any['name']= self.obj1581
      self.RHS.addNode(self.obj158)

      self.obj159=GenericGraphEdge(parent)

      self.obj159.GGLabel.setValue(3)
      self.obj159.graphClass_= graph_GenericGraphEdge
      if parent.genGraphics:
         from graph_GenericGraphEdge import *
         new_obj = graph_GenericGraphEdge(298.0,214.0,self.obj159)
      else: new_obj = None
      self.obj159.graphObject_ = new_obj
      self.RHS.addNode(self.obj159)
      self.obj157.out_connections_.append(self.obj155)
      self.obj155.in_connections_.append(self.obj157)
      self.obj157.graphObject_.pendingConnections.append((self.obj157.graphObject_.tag, self.obj155.graphObject_.tag, [219.99999999999994, 112.99999999999997, 340.0, 112.99999999999997], 2, 0))
      self.obj158.out_connections_.append(self.obj159)
      self.obj159.in_connections_.append(self.obj158)
      self.obj158.graphObject_.pendingConnections.append((self.obj158.graphObject_.tag, self.obj159.graphObject_.tag, [366.0, 213.99999999999994, 298.0, 213.99999999999994], 2, 0))
      self.obj158.out_connections_.append(self.obj157)
      self.obj157.in_connections_.append(self.obj158)
      self.obj158.graphObject_.pendingConnections.append((self.obj158.graphObject_.tag, self.obj157.graphObject_.tag, [382.0, 200.0, 340.0, 112.99999999999997], 2, 0))
      self.obj159.out_connections_.append(self.obj156)
      self.obj156.in_connections_.append(self.obj159)
      self.obj159.graphObject_.pendingConnections.append((self.obj159.graphObject_.tag, self.obj156.graphObject_.tag, [217.99999999999994, 214.0, 298.0, 213.99999999999994], 2, 0))
   def condition(self, graphID, isograph, atom3i):
      return 1
      

   def action(self, graphID, isograph, atom3i):
      pass

