# _ CapacityConstraintOnPl2Tr.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from RoadSection import *
from ASG_Traffic import *
from Capacity import *
from GenericGraphNode import *
from ASG_PetriNets import *
from Source2Section import *
from tran2pl import *
from CapacityOf import *
from FlowTo import *
from PNPlace import *
from Source import *
from Sink import *
from ASG_GenericGraph import *
from Section2Sink import *
from pl2tran import *
from GenericGraphEdge import *
from PNTransition import *
class CapacityConstraintOnPl2Tr (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 6)
      self.TimeDelay = ATOM3Integer(2)
      self.exactMatch = 1
      self.LHS = ASG_Traffic(parent)
      self.LHS.merge(ASG_PetriNets(parent))
      self.LHS.merge(ASG_GenericGraph(parent))

      self.obj79=RoadSection(parent)

      self.obj79.num_vehicles.setNone()
      self.obj79.name.setValue('')
      self.obj79.GGLabel.setValue(1)
      self.obj79.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(143.0,107.0,self.obj79)
      else: new_obj = None
      self.obj79.graphObject_ = new_obj
      self.LHS.addNode(self.obj79)

      self.obj80=CapacityOf(parent)

      self.obj80.GGLabel.setValue(7)
      self.obj80.graphClass_= graph_CapacityOf
      if parent.genGraphics:
         from graph_CapacityOf import *
         new_obj = graph_CapacityOf(247.0,120.0,self.obj80)
      else: new_obj = None
      self.obj80.graphObject_ = new_obj
      self.LHS.addNode(self.obj80)

      self.obj81=PNPlace(parent)

      self.obj81.tokens.setNone()
      self.obj81.name.setValue('')
      self.obj81.GGLabel.setValue(2)
      self.obj81.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(159.0,218.0,self.obj81)
      else: new_obj = None
      self.obj81.graphObject_ = new_obj
      self.LHS.addNode(self.obj81)

      self.obj82=PNPlace(parent)

      self.obj82.tokens.setNone()
      self.obj82.name.setValue('')
      self.obj82.GGLabel.setValue(6)
      self.obj82.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(284.0,103.0,self.obj82)
      else: new_obj = None
      self.obj82.graphObject_ = new_obj
      self.LHS.addNode(self.obj82)

      self.obj83=pl2tran(parent)

      self.obj83.weight.setNone()
      self.obj83.GGLabel.setValue(5)
      self.obj83.graphClass_= graph_pl2tran
      if parent.genGraphics:
         from graph_pl2tran import *
         new_obj = graph_pl2tran(260.5,234.5,self.obj83)
      else: new_obj = None
      self.obj83.graphObject_ = new_obj
      self.LHS.addNode(self.obj83)

      self.obj84=PNTransition(parent)

      self.obj84.name.setValue('')
      self.obj84.GGLabel.setValue(4)
      self.obj84.graphClass_= graph_PNTransition
      if parent.genGraphics:
         from graph_PNTransition import *
         new_obj = graph_PNTransition(286.0,283.0,self.obj84)
      else: new_obj = None
      self.obj84.graphObject_ = new_obj
      self.LHS.addNode(self.obj84)

      self.obj85=GenericGraphEdge(parent)

      self.obj85.GGLabel.setValue(3)
      self.obj85.graphClass_= graph_GenericGraphEdge
      if parent.genGraphics:
         from graph_GenericGraphEdge import *
         new_obj = graph_GenericGraphEdge(183.0,166.0,self.obj85)
      else: new_obj = None
      self.obj85.graphObject_ = new_obj
      self.LHS.addNode(self.obj85)
      self.obj80.out_connections_.append(self.obj79)
      self.obj79.in_connections_.append(self.obj80)
      self.obj80.graphObject_.pendingConnections.append((self.obj80.graphObject_.tag, self.obj79.graphObject_.tag, [183.0, 119.99999999999997, 246.99999999999994, 119.99999999999997], 2, 0))
      self.obj81.out_connections_.append(self.obj83)
      self.obj83.in_connections_.append(self.obj81)
      self.obj81.graphObject_.pendingConnections.append((self.obj81.graphObject_.tag, self.obj83.graphObject_.tag, [201.0, 234.99999999999994, 260.49999999999994, 234.49999999999994], 2, 0))
      self.obj81.out_connections_.append(self.obj85)
      self.obj85.in_connections_.append(self.obj81)
      self.obj81.graphObject_.pendingConnections.append((self.obj81.graphObject_.tag, self.obj85.graphObject_.tag, [183.0, 220.99999999999994, 183.0, 166.0], 2, 0))
      self.obj82.out_connections_.append(self.obj80)
      self.obj80.in_connections_.append(self.obj82)
      self.obj82.graphObject_.pendingConnections.append((self.obj82.graphObject_.tag, self.obj80.graphObject_.tag, [292.0, 119.99999999999997, 246.99999999999994, 119.99999999999997], 2, 0))
      self.obj83.out_connections_.append(self.obj84)
      self.obj84.in_connections_.append(self.obj83)
      self.obj83.graphObject_.pendingConnections.append((self.obj83.graphObject_.tag, self.obj84.graphObject_.tag, [319.0, 291.0, 260.49999999999994, 234.49999999999994], 2, 0))
      self.obj85.out_connections_.append(self.obj79)
      self.obj79.in_connections_.append(self.obj85)
      self.obj85.graphObject_.pendingConnections.append((self.obj85.graphObject_.tag, self.obj79.graphObject_.tag, [183.0, 119.99999999999997, 183.0, 166.0], 2, 0))
      self.RHS = ASG_Traffic(parent)
      self.RHS.merge(ASG_PetriNets(parent))
      self.RHS.merge(ASG_GenericGraph(parent))

      self.obj89=RoadSection(parent)

      self.obj89.num_vehicles.setValue(0)
      self.obj89.name.setValue('')
      self.obj89.GGLabel.setValue(1)
      self.obj89.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(143.0,107.0,self.obj89)
      else: new_obj = None
      self.obj89.graphObject_ = new_obj
      self.obj890= AttrCalc()
      self.obj890.Copy=ATOM3Boolean()
      self.obj890.Copy.setValue(('Copy from LHS', 1))
      self.obj890.Copy.config = 0
      self.obj890.Specify=ATOM3Constraint()
      self.obj890.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj89.GGset2Any['num_vehicles']= self.obj890
      self.obj891= AttrCalc()
      self.obj891.Copy=ATOM3Boolean()
      self.obj891.Copy.setValue(('Copy from LHS', 1))
      self.obj891.Copy.config = 0
      self.obj891.Specify=ATOM3Constraint()
      self.obj891.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj89.GGset2Any['name']= self.obj891
      self.RHS.addNode(self.obj89)

      self.obj90=CapacityOf(parent)

      self.obj90.GGLabel.setValue(7)
      self.obj90.graphClass_= graph_CapacityOf
      if parent.genGraphics:
         from graph_CapacityOf import *
         new_obj = graph_CapacityOf(248.0,120.0,self.obj90)
      else: new_obj = None
      self.obj90.graphObject_ = new_obj
      self.RHS.addNode(self.obj90)

      self.obj91=PNPlace(parent)

      self.obj91.tokens.setValue(0)
      self.obj91.name.setValue('0')
      self.obj91.GGLabel.setValue(2)
      self.obj91.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(159.0,226.0,self.obj91)
      else: new_obj = None
      self.obj91.graphObject_ = new_obj
      self.obj910= AttrCalc()
      self.obj910.Copy=ATOM3Boolean()
      self.obj910.Copy.setValue(('Copy from LHS', 1))
      self.obj910.Copy.config = 0
      self.obj910.Specify=ATOM3Constraint()
      self.obj910.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj91.GGset2Any['tokens']= self.obj910
      self.obj911= AttrCalc()
      self.obj911.Copy=ATOM3Boolean()
      self.obj911.Copy.setValue(('Copy from LHS', 1))
      self.obj911.Copy.config = 0
      self.obj911.Specify=ATOM3Constraint()
      self.obj911.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj91.GGset2Any['name']= self.obj911
      self.RHS.addNode(self.obj91)

      self.obj92=PNPlace(parent)

      self.obj92.tokens.setNone()
      self.obj92.name.setValue('')
      self.obj92.GGLabel.setValue(6)
      self.obj92.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(289.0,103.0,self.obj92)
      else: new_obj = None
      self.obj92.graphObject_ = new_obj
      self.obj920= AttrCalc()
      self.obj920.Copy=ATOM3Boolean()
      self.obj920.Copy.setValue(('Copy from LHS', 1))
      self.obj920.Copy.config = 0
      self.obj920.Specify=ATOM3Constraint()
      self.obj920.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj92.GGset2Any['tokens']= self.obj920
      self.obj921= AttrCalc()
      self.obj921.Copy=ATOM3Boolean()
      self.obj921.Copy.setValue(('Copy from LHS', 1))
      self.obj921.Copy.config = 0
      self.obj921.Specify=ATOM3Constraint()
      self.obj921.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj92.GGset2Any['name']= self.obj921
      self.RHS.addNode(self.obj92)

      self.obj93=pl2tran(parent)

      self.obj93.weight.setNone()
      self.obj93.GGLabel.setValue(5)
      self.obj93.graphClass_= graph_pl2tran
      if parent.genGraphics:
         from graph_pl2tran import *
         new_obj = graph_pl2tran(273.5,242.5,self.obj93)
      else: new_obj = None
      self.obj93.graphObject_ = new_obj
      self.obj930= AttrCalc()
      self.obj930.Copy=ATOM3Boolean()
      self.obj930.Copy.setValue(('Copy from LHS', 1))
      self.obj930.Copy.config = 0
      self.obj930.Specify=ATOM3Constraint()
      self.obj930.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj93.GGset2Any['weight']= self.obj930
      self.RHS.addNode(self.obj93)

      self.obj94=PNTransition(parent)

      self.obj94.name.setValue('')
      self.obj94.GGLabel.setValue(4)
      self.obj94.graphClass_= graph_PNTransition
      if parent.genGraphics:
         from graph_PNTransition import *
         new_obj = graph_PNTransition(281.0,297.0,self.obj94)
      else: new_obj = None
      self.obj94.graphObject_ = new_obj
      self.obj940= AttrCalc()
      self.obj940.Copy=ATOM3Boolean()
      self.obj940.Copy.setValue(('Copy from LHS', 1))
      self.obj940.Copy.config = 0
      self.obj940.Specify=ATOM3Constraint()
      self.obj940.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj94.GGset2Any['name']= self.obj940
      self.RHS.addNode(self.obj94)

      self.obj95=tran2pl(parent)

      self.obj95.weight.setValue(1)
      self.obj95.GGLabel.setValue(8)
      self.obj95.graphClass_= graph_tran2pl
      if parent.genGraphics:
         from graph_tran2pl import *
         new_obj = graph_tran2pl(313.0,225.0,self.obj95)
      else: new_obj = None
      self.obj95.graphObject_ = new_obj
      self.obj950= AttrCalc()
      self.obj950.Copy=ATOM3Boolean()
      self.obj950.Copy.setValue(('Copy from LHS', 0))
      self.obj950.Copy.config = 0
      self.obj950.Specify=ATOM3Constraint()
      self.obj950.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj95.GGset2Any['weight']= self.obj950
      self.RHS.addNode(self.obj95)

      self.obj96=GenericGraphEdge(parent)

      self.obj96.GGLabel.setValue(3)
      self.obj96.graphClass_= graph_GenericGraphEdge
      if parent.genGraphics:
         from graph_GenericGraphEdge import *
         new_obj = graph_GenericGraphEdge(183.0,170.0,self.obj96)
      else: new_obj = None
      self.obj96.graphObject_ = new_obj
      self.RHS.addNode(self.obj96)
      self.obj90.out_connections_.append(self.obj89)
      self.obj89.in_connections_.append(self.obj90)
      self.obj90.graphObject_.pendingConnections.append((self.obj90.graphObject_.tag, self.obj89.graphObject_.tag, [183.0, 119.99999999999997, 247.99999999999994, 119.99999999999997], 2, 0))
      self.obj91.out_connections_.append(self.obj93)
      self.obj93.in_connections_.append(self.obj91)
      self.obj91.graphObject_.pendingConnections.append((self.obj91.graphObject_.tag, self.obj93.graphObject_.tag, [201.0, 242.99999999999994, 273.5, 242.49999999999994], 2, 0))
      self.obj91.out_connections_.append(self.obj96)
      self.obj96.in_connections_.append(self.obj91)
      self.obj91.graphObject_.pendingConnections.append((self.obj91.graphObject_.tag, self.obj96.graphObject_.tag, [183.0, 228.99999999999994, 183.0, 170.0], 2, 0))
      self.obj92.out_connections_.append(self.obj90)
      self.obj90.in_connections_.append(self.obj92)
      self.obj92.graphObject_.pendingConnections.append((self.obj92.graphObject_.tag, self.obj90.graphObject_.tag, [297.0, 119.99999999999997, 247.99999999999994, 119.99999999999997], 2, 0))
      self.obj93.out_connections_.append(self.obj94)
      self.obj94.in_connections_.append(self.obj93)
      self.obj93.graphObject_.pendingConnections.append((self.obj93.graphObject_.tag, self.obj94.graphObject_.tag, [314.0, 305.0, 273.5, 242.49999999999994], 2, 0))
      self.obj94.out_connections_.append(self.obj95)
      self.obj95.in_connections_.append(self.obj94)
      self.obj94.graphObject_.pendingConnections.append((self.obj94.graphObject_.tag, self.obj95.graphObject_.tag, [314.0, 305.0, 313.0, 224.99999999999994], 2, 0))
      self.obj95.out_connections_.append(self.obj92)
      self.obj92.in_connections_.append(self.obj95)
      self.obj95.graphObject_.pendingConnections.append((self.obj95.graphObject_.tag, self.obj92.graphObject_.tag, [314.0, 136.0, 313.0, 224.99999999999994], 2, 0))
      self.obj96.out_connections_.append(self.obj89)
      self.obj89.in_connections_.append(self.obj96)
      self.obj96.graphObject_.pendingConnections.append((self.obj96.graphObject_.tag, self.obj89.graphObject_.tag, [183.0, 119.99999999999997, 183.0, 170.0], 2, 0))
   def condition(self, graphID, isograph, atom3i):
      cap_place = self.getMatched( graphID, self.LHS.nodeWithLabel(6))
      out_trans = self.getMatched( graphID, self.LHS.nodeWithLabel(4))
      capacity_transition_absent = True
      for in_link in cap_place.in_connections_:
       for out_link in out_trans.out_connections_:
        if (in_link == out_link) and isinstance(in_link,tran2pl): 
         capacity_transition_absent = False
         break
      return capacity_transition_absent
      
      
      
      
      

   def action(self, graphID, isograph, atom3i):
      pass

