# _ CapacityConstraintOnTr2Pl.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from RoadSection import *
from ASG_Traffic import *
from Capacity import *
from GenericGraphNode import *
from ASG_PetriNets import *
from Source2Section import *
from tran2pl import *
from CapacityOf import *
from FlowTo import *
from PNPlace import *
from Source import *
from Sink import *
from PNTransition import *
from Section2Sink import *
from pl2tran import *
from GenericGraphEdge import *
from ASG_GenericGraph import *
class CapacityConstraintOnTr2Pl (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 7)
      self.TimeDelay = ATOM3Integer(2)
      self.exactMatch = 1
      self.LHS = ASG_Traffic(parent)
      self.LHS.merge(ASG_GenericGraph(parent))
      self.LHS.merge(ASG_PetriNets(parent))

      self.obj103=RoadSection(parent)

      self.obj103.num_vehicles.setNone()
      self.obj103.name.setValue('')
      self.obj103.GGLabel.setValue(1)
      self.obj103.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(138.0,88.0,self.obj103)
      else: new_obj = None
      self.obj103.graphObject_ = new_obj
      self.LHS.addNode(self.obj103)

      self.obj104=CapacityOf(parent)

      self.obj104.GGLabel.setValue(7)
      self.obj104.graphClass_= graph_CapacityOf
      if parent.genGraphics:
         from graph_CapacityOf import *
         new_obj = graph_CapacityOf(223.0,101.0,self.obj104)
      else: new_obj = None
      self.obj104.graphObject_ = new_obj
      self.LHS.addNode(self.obj104)

      self.obj105=GenericGraphEdge(parent)

      self.obj105.GGLabel.setValue(3)
      self.obj105.graphClass_= graph_GenericGraphEdge
      if parent.genGraphics:
         from graph_GenericGraphEdge import *
         new_obj = graph_GenericGraphEdge(178.0,152.0,self.obj105)
      else: new_obj = None
      self.obj105.graphObject_ = new_obj
      self.LHS.addNode(self.obj105)

      self.obj106=PNPlace(parent)

      self.obj106.tokens.setNone()
      self.obj106.name.setValue('')
      self.obj106.GGLabel.setValue(2)
      self.obj106.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(154.0,189.0,self.obj106)
      else: new_obj = None
      self.obj106.graphObject_ = new_obj
      self.LHS.addNode(self.obj106)

      self.obj107=PNPlace(parent)

      self.obj107.tokens.setNone()
      self.obj107.name.setValue('')
      self.obj107.GGLabel.setValue(6)
      self.obj107.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(256.0,84.0,self.obj107)
      else: new_obj = None
      self.obj107.graphObject_ = new_obj
      self.LHS.addNode(self.obj107)

      self.obj108=PNTransition(parent)

      self.obj108.name.setValue('')
      self.obj108.GGLabel.setValue(4)
      self.obj108.graphClass_= graph_PNTransition
      if parent.genGraphics:
         from graph_PNTransition import *
         new_obj = graph_PNTransition(258.0,252.0,self.obj108)
      else: new_obj = None
      self.obj108.graphObject_ = new_obj
      self.LHS.addNode(self.obj108)

      self.obj109=tran2pl(parent)

      self.obj109.weight.setNone()
      self.obj109.GGLabel.setValue(5)
      self.obj109.graphClass_= graph_tran2pl
      if parent.genGraphics:
         from graph_tran2pl import *
         new_obj = graph_tran2pl(256.0,205.5,self.obj109)
      else: new_obj = None
      self.obj109.graphObject_ = new_obj
      self.LHS.addNode(self.obj109)
      self.obj104.out_connections_.append(self.obj103)
      self.obj103.in_connections_.append(self.obj104)
      self.obj104.graphObject_.pendingConnections.append((self.obj104.graphObject_.tag, self.obj103.graphObject_.tag, [178.0, 101.0, 222.99999999999994, 100.99999999999991], 2, 0))
      self.obj105.out_connections_.append(self.obj103)
      self.obj103.in_connections_.append(self.obj105)
      self.obj105.graphObject_.pendingConnections.append((self.obj105.graphObject_.tag, self.obj103.graphObject_.tag, [178.0, 101.0, 178.0, 152.0], 2, 0))
      self.obj106.out_connections_.append(self.obj105)
      self.obj105.in_connections_.append(self.obj106)
      self.obj106.graphObject_.pendingConnections.append((self.obj106.graphObject_.tag, self.obj105.graphObject_.tag, [178.0, 192.0, 178.0, 152.0], 2, 0))
      self.obj106.out_connections_.append(self.obj105)
      self.obj105.in_connections_.append(self.obj106)
      self.obj106.graphObject_.pendingConnections.append((self.obj106.graphObject_.tag, self.obj105.graphObject_.tag, [178.0, 192.0, 178.0, 152.0], 2, 0))
      self.obj107.out_connections_.append(self.obj104)
      self.obj104.in_connections_.append(self.obj107)
      self.obj107.graphObject_.pendingConnections.append((self.obj107.graphObject_.tag, self.obj104.graphObject_.tag, [264.0, 100.99999999999993, 222.99999999999994, 100.99999999999991], 2, 0))
      self.obj107.out_connections_.append(self.obj104)
      self.obj104.in_connections_.append(self.obj107)
      self.obj107.graphObject_.pendingConnections.append((self.obj107.graphObject_.tag, self.obj104.graphObject_.tag, [264.0, 100.99999999999993, 222.99999999999994, 100.99999999999991], 2, 0))
      self.obj108.out_connections_.append(self.obj109)
      self.obj109.in_connections_.append(self.obj108)
      self.obj108.graphObject_.pendingConnections.append((self.obj108.graphObject_.tag, self.obj109.graphObject_.tag, [291.0, 259.99999999999994, 255.99999999999994, 205.5], 2, 0))
      self.obj108.out_connections_.append(self.obj109)
      self.obj109.in_connections_.append(self.obj108)
      self.obj108.graphObject_.pendingConnections.append((self.obj108.graphObject_.tag, self.obj109.graphObject_.tag, [291.0, 259.99999999999994, 255.99999999999994, 205.5], 2, 0))
      self.obj109.out_connections_.append(self.obj106)
      self.obj106.in_connections_.append(self.obj109)
      self.obj109.graphObject_.pendingConnections.append((self.obj109.graphObject_.tag, self.obj106.graphObject_.tag, [196.0, 206.0, 255.99999999999994, 205.5], 2, 0))
      self.obj109.out_connections_.append(self.obj106)
      self.obj106.in_connections_.append(self.obj109)
      self.obj109.graphObject_.pendingConnections.append((self.obj109.graphObject_.tag, self.obj106.graphObject_.tag, [196.0, 206.0, 255.99999999999994, 205.5], 2, 0))
      self.RHS = ASG_Traffic(parent)
      self.RHS.merge(ASG_GenericGraph(parent))
      self.RHS.merge(ASG_PetriNets(parent))

      self.obj113=RoadSection(parent)

      self.obj113.num_vehicles.setValue(0)
      self.obj113.name.setValue('')
      self.obj113.GGLabel.setValue(1)
      self.obj113.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(94.0,74.0,self.obj113)
      else: new_obj = None
      self.obj113.graphObject_ = new_obj
      self.obj1130= AttrCalc()
      self.obj1130.Copy=ATOM3Boolean()
      self.obj1130.Copy.setValue(('Copy from LHS', 1))
      self.obj1130.Copy.config = 0
      self.obj1130.Specify=ATOM3Constraint()
      self.obj1130.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj113.GGset2Any['num_vehicles']= self.obj1130
      self.obj1131= AttrCalc()
      self.obj1131.Copy=ATOM3Boolean()
      self.obj1131.Copy.setValue(('Copy from LHS', 1))
      self.obj1131.Copy.config = 0
      self.obj1131.Specify=ATOM3Constraint()
      self.obj1131.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj113.GGset2Any['name']= self.obj1131
      self.RHS.addNode(self.obj113)

      self.obj114=CapacityOf(parent)

      self.obj114.GGLabel.setValue(7)
      self.obj114.graphClass_= graph_CapacityOf
      if parent.genGraphics:
         from graph_CapacityOf import *
         new_obj = graph_CapacityOf(197.0,87.0,self.obj114)
      else: new_obj = None
      self.obj114.graphObject_ = new_obj
      self.RHS.addNode(self.obj114)

      self.obj115=GenericGraphEdge(parent)

      self.obj115.GGLabel.setValue(3)
      self.obj115.graphClass_= graph_GenericGraphEdge
      if parent.genGraphics:
         from graph_GenericGraphEdge import *
         new_obj = graph_GenericGraphEdge(134.0,150.0,self.obj115)
      else: new_obj = None
      self.obj115.graphObject_ = new_obj
      self.RHS.addNode(self.obj115)

      self.obj116=PNPlace(parent)

      self.obj116.tokens.setValue(0)
      self.obj116.name.setValue('0')
      self.obj116.GGLabel.setValue(2)
      self.obj116.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(110.0,196.0,self.obj116)
      else: new_obj = None
      self.obj116.graphObject_ = new_obj
      self.obj1160= AttrCalc()
      self.obj1160.Copy=ATOM3Boolean()
      self.obj1160.Copy.setValue(('Copy from LHS', 1))
      self.obj1160.Copy.config = 0
      self.obj1160.Specify=ATOM3Constraint()
      self.obj1160.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj116.GGset2Any['tokens']= self.obj1160
      self.obj1161= AttrCalc()
      self.obj1161.Copy=ATOM3Boolean()
      self.obj1161.Copy.setValue(('Copy from LHS', 1))
      self.obj1161.Copy.config = 0
      self.obj1161.Specify=ATOM3Constraint()
      self.obj1161.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj116.GGset2Any['name']= self.obj1161
      self.RHS.addNode(self.obj116)

      self.obj117=PNPlace(parent)

      self.obj117.tokens.setValue(0)
      self.obj117.name.setValue('1')
      self.obj117.GGLabel.setValue(6)
      self.obj117.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(240.0,70.0,self.obj117)
      else: new_obj = None
      self.obj117.graphObject_ = new_obj
      self.obj1170= AttrCalc()
      self.obj1170.Copy=ATOM3Boolean()
      self.obj1170.Copy.setValue(('Copy from LHS', 1))
      self.obj1170.Copy.config = 0
      self.obj1170.Specify=ATOM3Constraint()
      self.obj1170.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj117.GGset2Any['tokens']= self.obj1170
      self.obj1171= AttrCalc()
      self.obj1171.Copy=ATOM3Boolean()
      self.obj1171.Copy.setValue(('Copy from LHS', 1))
      self.obj1171.Copy.config = 0
      self.obj1171.Specify=ATOM3Constraint()
      self.obj1171.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj117.GGset2Any['name']= self.obj1171
      self.RHS.addNode(self.obj117)

      self.obj118=pl2tran(parent)

      self.obj118.weight.setValue(1)
      self.obj118.GGLabel.setValue(8)
      self.obj118.graphClass_= graph_pl2tran
      if parent.genGraphics:
         from graph_pl2tran import *
         new_obj = graph_pl2tran(266.5,188.5,self.obj118)
      else: new_obj = None
      self.obj118.graphObject_ = new_obj
      self.RHS.addNode(self.obj118)

      self.obj119=PNTransition(parent)

      self.obj119.name.setValue('0')
      self.obj119.GGLabel.setValue(4)
      self.obj119.graphClass_= graph_PNTransition
      if parent.genGraphics:
         from graph_PNTransition import *
         new_obj = graph_PNTransition(233.0,272.0,self.obj119)
      else: new_obj = None
      self.obj119.graphObject_ = new_obj
      self.obj1190= AttrCalc()
      self.obj1190.Copy=ATOM3Boolean()
      self.obj1190.Copy.setValue(('Copy from LHS', 1))
      self.obj1190.Copy.config = 0
      self.obj1190.Specify=ATOM3Constraint()
      self.obj1190.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj119.GGset2Any['name']= self.obj1190
      self.RHS.addNode(self.obj119)

      self.obj120=tran2pl(parent)

      self.obj120.weight.setValue(1)
      self.obj120.GGLabel.setValue(5)
      self.obj120.graphClass_= graph_tran2pl
      if parent.genGraphics:
         from graph_tran2pl import *
         new_obj = graph_tran2pl(236.5,211.5,self.obj120)
      else: new_obj = None
      self.obj120.graphObject_ = new_obj
      self.obj1200= AttrCalc()
      self.obj1200.Copy=ATOM3Boolean()
      self.obj1200.Copy.setValue(('Copy from LHS', 1))
      self.obj1200.Copy.config = 0
      self.obj1200.Specify=ATOM3Constraint()
      self.obj1200.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj120.GGset2Any['weight']= self.obj1200
      self.RHS.addNode(self.obj120)
      self.obj114.out_connections_.append(self.obj113)
      self.obj113.in_connections_.append(self.obj114)
      self.obj114.graphObject_.pendingConnections.append((self.obj114.graphObject_.tag, self.obj113.graphObject_.tag, [134.0, 87.0, 197.0, 87.0], 2, 0))
      self.obj115.out_connections_.append(self.obj113)
      self.obj113.in_connections_.append(self.obj115)
      self.obj115.graphObject_.pendingConnections.append((self.obj115.graphObject_.tag, self.obj113.graphObject_.tag, [134.0, 87.0, 133.99999999999997, 150.0], 2, 0))
      self.obj116.out_connections_.append(self.obj115)
      self.obj115.in_connections_.append(self.obj116)
      self.obj116.graphObject_.pendingConnections.append((self.obj116.graphObject_.tag, self.obj115.graphObject_.tag, [134.0, 199.0, 133.99999999999997, 150.0], 2, 0))
      self.obj117.out_connections_.append(self.obj114)
      self.obj114.in_connections_.append(self.obj117)
      self.obj117.graphObject_.pendingConnections.append((self.obj117.graphObject_.tag, self.obj114.graphObject_.tag, [247.99999999999994, 87.0, 197.0, 87.0], 2, 0))
      self.obj117.out_connections_.append(self.obj118)
      self.obj118.in_connections_.append(self.obj117)
      self.obj117.graphObject_.pendingConnections.append((self.obj117.graphObject_.tag, self.obj118.graphObject_.tag, [265.0, 102.99999999999997, 266.49999999999994, 188.5], 2, 0))
      self.obj118.out_connections_.append(self.obj119)
      self.obj119.in_connections_.append(self.obj118)
      self.obj118.graphObject_.pendingConnections.append((self.obj118.graphObject_.tag, self.obj119.graphObject_.tag, [266.0, 279.99999999999994, 266.49999999999994, 188.5], 2, 0))
      self.obj119.out_connections_.append(self.obj120)
      self.obj120.in_connections_.append(self.obj119)
      self.obj119.graphObject_.pendingConnections.append((self.obj119.graphObject_.tag, self.obj120.graphObject_.tag, [266.0, 279.99999999999994, 236.49999999999994, 211.5], 2, 0))
      self.obj120.out_connections_.append(self.obj116)
      self.obj116.in_connections_.append(self.obj120)
      self.obj120.graphObject_.pendingConnections.append((self.obj120.graphObject_.tag, self.obj116.graphObject_.tag, [152.0, 212.99999999999994, 236.49999999999994, 211.5], 2, 0))
   def condition(self, graphID, isograph, atom3i):
      cap_place = self.getMatched( graphID, self.LHS.nodeWithLabel(6))
      in_trans = self.getMatched( graphID, self.LHS.nodeWithLabel(4))
      capacity_transition_absent = True
      for out_link in cap_place.out_connections_:
       for in_link in in_trans.in_connections_:
        if (in_link == out_link) and isinstance(in_link, pl2tran): 
         capacity_transition_absent = False
         break
      return capacity_transition_absent
      
      
      
      
      
      
      
      
      
      

   def action(self, graphID, isograph, atom3i):
      pass

