# _ FlowTo2PNTransition.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from RoadSection import *
from ASG_Traffic import *
from Capacity import *
from GenericGraphNode import *
from ASG_PetriNets import *
from Source2Section import *
from tran2pl import *
from CapacityOf import *
from FlowTo import *
from PNPlace import *
from Source import *
from Sink import *
from ASG_GenericGraph import *
from Section2Sink import *
from pl2tran import *
from GenericGraphEdge import *
from PNTransition import *
class FlowTo2PNTransition (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 2)
      self.TimeDelay = ATOM3Integer(2)
      self.exactMatch = 1
      self.LHS = ASG_Traffic(parent)
      self.LHS.merge(ASG_PetriNets(parent))
      self.LHS.merge(ASG_GenericGraph(parent))

      self.obj42=RoadSection(parent)

      self.obj42.num_vehicles.setNone()
      self.obj42.name.setValue('')
      self.obj42.GGLabel.setValue(1)
      self.obj42.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(210.0,159.0,self.obj42)
      else: new_obj = None
      self.obj42.graphObject_ = new_obj
      self.LHS.addNode(self.obj42)

      self.obj43=RoadSection(parent)

      self.obj43.num_vehicles.setNone()
      self.obj43.name.setValue('')
      self.obj43.GGLabel.setValue(2)
      self.obj43.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(364.0,158.0,self.obj43)
      else: new_obj = None
      self.obj43.graphObject_ = new_obj
      self.LHS.addNode(self.obj43)

      self.obj44=FlowTo(parent)

      self.obj44.GGLabel.setValue(7)
      self.obj44.graphClass_= graph_FlowTo
      if parent.genGraphics:
         from graph_FlowTo import *
         new_obj = graph_FlowTo(323.5,171.5,self.obj44)
      else: new_obj = None
      self.obj44.graphObject_ = new_obj
      self.LHS.addNode(self.obj44)

      self.obj45=PNPlace(parent)

      self.obj45.tokens.setNone()
      self.obj45.name.setValue('')
      self.obj45.GGLabel.setValue(3)
      self.obj45.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(159.0,236.0,self.obj45)
      else: new_obj = None
      self.obj45.graphObject_ = new_obj
      self.LHS.addNode(self.obj45)

      self.obj46=PNPlace(parent)

      self.obj46.tokens.setNone()
      self.obj46.name.setValue('')
      self.obj46.GGLabel.setValue(4)
      self.obj46.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(335.0,237.0,self.obj46)
      else: new_obj = None
      self.obj46.graphObject_ = new_obj
      self.LHS.addNode(self.obj46)

      self.obj47=GenericGraphEdge(parent)

      self.obj47.GGLabel.setValue(5)
      self.obj47.graphClass_= graph_GenericGraphEdge
      if parent.genGraphics:
         from graph_GenericGraphEdge import *
         new_obj = graph_GenericGraphEdge(216.0,206.0,self.obj47)
      else: new_obj = None
      self.obj47.graphObject_ = new_obj
      self.LHS.addNode(self.obj47)

      self.obj48=GenericGraphEdge(parent)

      self.obj48.GGLabel.setValue(6)
      self.obj48.graphClass_= graph_GenericGraphEdge
      if parent.genGraphics:
         from graph_GenericGraphEdge import *
         new_obj = graph_GenericGraphEdge(383.0,206.0,self.obj48)
      else: new_obj = None
      self.obj48.graphObject_ = new_obj
      self.LHS.addNode(self.obj48)
      self.obj42.out_connections_.append(self.obj44)
      self.obj44.in_connections_.append(self.obj42)
      self.obj42.graphObject_.pendingConnections.append((self.obj42.graphObject_.tag, self.obj44.graphObject_.tag, [249.99999999999986, 172.0, 323.50000000000017, 171.49999999999969], 2, 0))
      self.obj44.out_connections_.append(self.obj43)
      self.obj43.in_connections_.append(self.obj44)
      self.obj44.graphObject_.pendingConnections.append((self.obj44.graphObject_.tag, self.obj43.graphObject_.tag, [404.00000000000023, 171.0, 323.50000000000017, 171.49999999999969], 2, 0))
      self.obj45.out_connections_.append(self.obj47)
      self.obj47.in_connections_.append(self.obj45)
      self.obj45.graphObject_.pendingConnections.append((self.obj45.graphObject_.tag, self.obj47.graphObject_.tag, [183.0, 239.00000000000003, 216.0, 206.0], 2, 0))
      self.obj46.out_connections_.append(self.obj48)
      self.obj48.in_connections_.append(self.obj46)
      self.obj46.graphObject_.pendingConnections.append((self.obj46.graphObject_.tag, self.obj48.graphObject_.tag, [359.00000000000017, 239.99999999999994, 383.00000000000006, 205.99999999999994], 2, 0))
      self.obj47.out_connections_.append(self.obj42)
      self.obj42.in_connections_.append(self.obj47)
      self.obj47.graphObject_.pendingConnections.append((self.obj47.graphObject_.tag, self.obj42.graphObject_.tag, [249.99999999999986, 172.0, 216.0, 206.0], 2, 0))
      self.obj48.out_connections_.append(self.obj43)
      self.obj43.in_connections_.append(self.obj48)
      self.obj48.graphObject_.pendingConnections.append((self.obj48.graphObject_.tag, self.obj43.graphObject_.tag, [404.00000000000023, 171.0, 383.00000000000006, 205.99999999999994], 2, 0))
      self.RHS = ASG_Traffic(parent)
      self.RHS.merge(ASG_PetriNets(parent))
      self.RHS.merge(ASG_GenericGraph(parent))

      self.obj52=RoadSection(parent)

      self.obj52.num_vehicles.setValue(0)
      self.obj52.name.setValue('')
      self.obj52.GGLabel.setValue(1)
      self.obj52.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(197.0,133.0,self.obj52)
      else: new_obj = None
      self.obj52.graphObject_ = new_obj
      self.obj520= AttrCalc()
      self.obj520.Copy=ATOM3Boolean()
      self.obj520.Copy.setValue(('Copy from LHS', 1))
      self.obj520.Copy.config = 0
      self.obj520.Specify=ATOM3Constraint()
      self.obj520.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj52.GGset2Any['num_vehicles']= self.obj520
      self.obj521= AttrCalc()
      self.obj521.Copy=ATOM3Boolean()
      self.obj521.Copy.setValue(('Copy from LHS', 1))
      self.obj521.Copy.config = 0
      self.obj521.Specify=ATOM3Constraint()
      self.obj521.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj52.GGset2Any['name']= self.obj521
      self.RHS.addNode(self.obj52)

      self.obj53=RoadSection(parent)

      self.obj53.num_vehicles.setValue(0)
      self.obj53.name.setValue('')
      self.obj53.GGLabel.setValue(2)
      self.obj53.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(415.0,131.0,self.obj53)
      else: new_obj = None
      self.obj53.graphObject_ = new_obj
      self.obj530= AttrCalc()
      self.obj530.Copy=ATOM3Boolean()
      self.obj530.Copy.setValue(('Copy from LHS', 1))
      self.obj530.Copy.config = 0
      self.obj530.Specify=ATOM3Constraint()
      self.obj530.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj53.GGset2Any['num_vehicles']= self.obj530
      self.obj531= AttrCalc()
      self.obj531.Copy=ATOM3Boolean()
      self.obj531.Copy.setValue(('Copy from LHS', 1))
      self.obj531.Copy.config = 0
      self.obj531.Specify=ATOM3Constraint()
      self.obj531.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj53.GGset2Any['name']= self.obj531
      self.RHS.addNode(self.obj53)

      self.obj54=PNPlace(parent)

      self.obj54.tokens.setValue(0)
      self.obj54.name.setValue('0')
      self.obj54.GGLabel.setValue(3)
      self.obj54.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(171.0,217.0,self.obj54)
      else: new_obj = None
      self.obj54.graphObject_ = new_obj
      self.obj540= AttrCalc()
      self.obj540.Copy=ATOM3Boolean()
      self.obj540.Copy.setValue(('Copy from LHS', 1))
      self.obj540.Copy.config = 0
      self.obj540.Specify=ATOM3Constraint()
      self.obj540.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj54.GGset2Any['tokens']= self.obj540
      self.obj541= AttrCalc()
      self.obj541.Copy=ATOM3Boolean()
      self.obj541.Copy.setValue(('Copy from LHS', 1))
      self.obj541.Copy.config = 0
      self.obj541.Specify=ATOM3Constraint()
      self.obj541.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj54.GGset2Any['name']= self.obj541
      self.RHS.addNode(self.obj54)

      self.obj55=PNPlace(parent)

      self.obj55.tokens.setValue(0)
      self.obj55.name.setValue('1')
      self.obj55.GGLabel.setValue(4)
      self.obj55.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(387.0,216.0,self.obj55)
      else: new_obj = None
      self.obj55.graphObject_ = new_obj
      self.obj550= AttrCalc()
      self.obj550.Copy=ATOM3Boolean()
      self.obj550.Copy.setValue(('Copy from LHS', 1))
      self.obj550.Copy.config = 0
      self.obj550.Specify=ATOM3Constraint()
      self.obj550.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj55.GGset2Any['tokens']= self.obj550
      self.obj551= AttrCalc()
      self.obj551.Copy=ATOM3Boolean()
      self.obj551.Copy.setValue(('Copy from LHS', 1))
      self.obj551.Copy.config = 0
      self.obj551.Specify=ATOM3Constraint()
      self.obj551.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj55.GGset2Any['name']= self.obj551
      self.RHS.addNode(self.obj55)

      self.obj56=pl2tran(parent)

      self.obj56.weight.setValue(1)
      self.obj56.GGLabel.setValue(9)
      self.obj56.graphClass_= graph_pl2tran
      if parent.genGraphics:
         from graph_pl2tran import *
         new_obj = graph_pl2tran(268.5,234.5,self.obj56)
      else: new_obj = None
      self.obj56.graphObject_ = new_obj
      self.obj560= AttrCalc()
      self.obj560.Copy=ATOM3Boolean()
      self.obj560.Copy.setValue(('Copy from LHS', 0))
      self.obj560.Copy.config = 0
      self.obj560.Specify=ATOM3Constraint()
      self.obj560.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj56.GGset2Any['weight']= self.obj560
      self.RHS.addNode(self.obj56)

      self.obj57=PNTransition(parent)

      self.obj57.name.setValue('0')
      self.obj57.GGLabel.setValue(8)
      self.obj57.graphClass_= graph_PNTransition
      if parent.genGraphics:
         from graph_PNTransition import *
         new_obj = graph_PNTransition(273.0,283.0,self.obj57)
      else: new_obj = None
      self.obj57.graphObject_ = new_obj
      self.obj570= AttrCalc()
      self.obj570.Copy=ATOM3Boolean()
      self.obj570.Copy.setValue(('Copy from LHS', 0))
      self.obj570.Copy.config = 0
      self.obj570.Specify=ATOM3Constraint()
      self.obj570.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj57.GGset2Any['name']= self.obj570
      self.RHS.addNode(self.obj57)

      self.obj58=tran2pl(parent)

      self.obj58.weight.setValue(1)
      self.obj58.GGLabel.setValue(10)
      self.obj58.graphClass_= graph_tran2pl
      if parent.genGraphics:
         from graph_tran2pl import *
         new_obj = graph_tran2pl(339.5,233.0,self.obj58)
      else: new_obj = None
      self.obj58.graphObject_ = new_obj
      self.obj580= AttrCalc()
      self.obj580.Copy=ATOM3Boolean()
      self.obj580.Copy.setValue(('Copy from LHS', 0))
      self.obj580.Copy.config = 0
      self.obj580.Specify=ATOM3Constraint()
      self.obj580.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj58.GGset2Any['weight']= self.obj580
      self.RHS.addNode(self.obj58)

      self.obj59=GenericGraphEdge(parent)

      self.obj59.GGLabel.setValue(5)
      self.obj59.graphClass_= graph_GenericGraphEdge
      if parent.genGraphics:
         from graph_GenericGraphEdge import *
         new_obj = graph_GenericGraphEdge(217.0,182.0,self.obj59)
      else: new_obj = None
      self.obj59.graphObject_ = new_obj
      self.RHS.addNode(self.obj59)

      self.obj60=GenericGraphEdge(parent)

      self.obj60.GGLabel.setValue(6)
      self.obj60.graphClass_= graph_GenericGraphEdge
      if parent.genGraphics:
         from graph_GenericGraphEdge import *
         new_obj = graph_GenericGraphEdge(433.0,184.0,self.obj60)
      else: new_obj = None
      self.obj60.graphObject_ = new_obj
      self.RHS.addNode(self.obj60)
      self.obj54.out_connections_.append(self.obj59)
      self.obj59.in_connections_.append(self.obj54)
      self.obj54.graphObject_.pendingConnections.append((self.obj54.graphObject_.tag, self.obj59.graphObject_.tag, [195.00000000000003, 219.99999999999994, 217.0, 182.0], 2, 0))
      self.obj54.out_connections_.append(self.obj56)
      self.obj56.in_connections_.append(self.obj54)
      self.obj54.graphObject_.pendingConnections.append((self.obj54.graphObject_.tag, self.obj56.graphObject_.tag, [213.0, 233.99999999999997, 268.5, 234.50000000000011], 2, 0))
      self.obj55.out_connections_.append(self.obj60)
      self.obj60.in_connections_.append(self.obj55)
      self.obj55.graphObject_.pendingConnections.append((self.obj55.graphObject_.tag, self.obj60.graphObject_.tag, [410.99999999999989, 218.99999999999994, 433.0, 184.0], 2, 0))
      self.obj56.out_connections_.append(self.obj57)
      self.obj57.in_connections_.append(self.obj56)
      self.obj56.graphObject_.pendingConnections.append((self.obj56.graphObject_.tag, self.obj57.graphObject_.tag, [305.99999999999994, 291.0, 268.5, 234.50000000000011], 2, 0))
      self.obj57.out_connections_.append(self.obj58)
      self.obj58.in_connections_.append(self.obj57)
      self.obj57.graphObject_.pendingConnections.append((self.obj57.graphObject_.tag, self.obj58.graphObject_.tag, [305.99999999999994, 291.0, 339.50000000000017, 232.99999999999997], 2, 0))
      self.obj58.out_connections_.append(self.obj55)
      self.obj55.in_connections_.append(self.obj58)
      self.obj58.graphObject_.pendingConnections.append((self.obj58.graphObject_.tag, self.obj55.graphObject_.tag, [395.0, 232.99999999999997, 339.50000000000017, 232.99999999999997], 2, 0))
      self.obj59.out_connections_.append(self.obj52)
      self.obj52.in_connections_.append(self.obj59)
      self.obj59.graphObject_.pendingConnections.append((self.obj59.graphObject_.tag, self.obj52.graphObject_.tag, [236.99999999999997, 146.0, 217.0, 182.0], 2, 0))
      self.obj60.out_connections_.append(self.obj53)
      self.obj53.in_connections_.append(self.obj60)
      self.obj60.graphObject_.pendingConnections.append((self.obj60.graphObject_.tag, self.obj53.graphObject_.tag, [455.00000000000006, 144.0, 433.0, 184.0], 2, 0))
   def condition(self, graphID, isograph, atom3i):
      return 1
      

   def action(self, graphID, isograph, atom3i):
      pass

