# _ RemoveRoadSection.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from RoadSection import *
from ASG_Traffic import *
from Capacity import *
from GenericGraphNode import *
from Source2Section import *
from CapacityOf import *
from FlowTo import *
from Source import *
from Sink import *
from Section2Sink import *
from GenericGraphEdge import *
from ASG_GenericGraph import *
class RemoveRoadSection (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 9)
      self.TimeDelay = ATOM3Integer(2)
      self.exactMatch = 1
      self.LHS = ASG_Traffic(parent)
      self.LHS.merge(ASG_GenericGraph(parent))

      self.obj138=RoadSection(parent)

      self.obj138.num_vehicles.setNone()
      self.obj138.name.setValue('')
      self.obj138.GGLabel.setValue(1)
      self.obj138.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(132.0,117.0,self.obj138)
      else: new_obj = None
      self.obj138.graphObject_ = new_obj
      self.LHS.addNode(self.obj138)

      self.obj139=GenericGraphEdge(parent)

      self.obj139.GGLabel.setValue(2)
      self.obj139.graphClass_= graph_GenericGraphEdge
      if parent.genGraphics:
         from graph_GenericGraphEdge import *
         new_obj = graph_GenericGraphEdge(153.0,198.0,self.obj139)
      else: new_obj = None
      self.obj139.graphObject_ = new_obj
      self.LHS.addNode(self.obj139)
      self.obj139.out_connections_.append(self.obj138)
      self.obj138.in_connections_.append(self.obj139)
      self.obj139.graphObject_.pendingConnections.append((self.obj139.graphObject_.tag, self.obj138.graphObject_.tag, [172.0, 130.0, 153.0, 198.0], 2, 0))
      self.RHS = ASG_Traffic(parent)
   def condition(self, graphID, isograph, atom3i):
      return 1
      

   def action(self, graphID, isograph, atom3i):
      pass

