# _ RoadSection2PNPlace.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from RoadSection import *
from ASG_Traffic import *
from Capacity import *
from Source2Section import *
from CapacityOf import *
from FlowTo import *
from Source import *
from Sink import *
from Section2Sink import *
from GenericGraphNode import *
from ASG_PetriNets import *
from tran2pl import *
from PNPlace import *
from ASG_GenericGraph import *
from pl2tran import *
from GenericGraphEdge import *
from PNTransition import *
class RoadSection2PNPlace (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 1)
      self.TimeDelay = ATOM3Integer(2)
      self.exactMatch = 1
      self.LHS = ASG_Traffic(parent)

      self.obj29=RoadSection(parent)

      self.obj29.num_vehicles.setNone()
      self.obj29.name.setValue('')
      self.obj29.GGLabel.setValue(1)
      self.obj29.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(187.0,159.0,self.obj29)
      else: new_obj = None
      self.obj29.graphObject_ = new_obj
      self.LHS.addNode(self.obj29)
      self.RHS = ASG_Traffic(parent)
      self.RHS.merge(ASG_PetriNets(parent))
      self.RHS.merge(ASG_GenericGraph(parent))

      self.obj33=RoadSection(parent)

      self.obj33.num_vehicles.setValue(0)
      self.obj33.name.setValue('')
      self.obj33.GGLabel.setValue(1)
      self.obj33.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(170.0,108.0,self.obj33)
      else: new_obj = None
      self.obj33.graphObject_ = new_obj
      self.obj330= AttrCalc()
      self.obj330.Copy=ATOM3Boolean()
      self.obj330.Copy.setValue(('Copy from LHS', 1))
      self.obj330.Copy.config = 0
      self.obj330.Specify=ATOM3Constraint()
      self.obj330.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj33.GGset2Any['num_vehicles']= self.obj330
      self.obj331= AttrCalc()
      self.obj331.Copy=ATOM3Boolean()
      self.obj331.Copy.setValue(('Copy from LHS', 1))
      self.obj331.Copy.config = 0
      self.obj331.Specify=ATOM3Constraint()
      self.obj331.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj33.GGset2Any['name']= self.obj331
      self.RHS.addNode(self.obj33)

      self.obj34=PNPlace(parent)

      self.obj34.tokens.setValue(0)
      self.obj34.name.setValue('0')
      self.obj34.GGLabel.setValue(2)
      self.obj34.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(114.0,198.0,self.obj34)
      else: new_obj = None
      self.obj34.graphObject_ = new_obj
      self.obj340= AttrCalc()
      self.obj340.Copy=ATOM3Boolean()
      self.obj340.Copy.setValue(('Copy from LHS', 0))
      self.obj340.Copy.config = 0
      self.obj340.Specify=ATOM3Constraint()
      self.obj340.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'return self.getMatched(graphID, self.LHS.nodeWithLabel(1)).num_vehicles.getValue()\n\n\n\n'))
      self.obj34.GGset2Any['tokens']= self.obj340
      self.obj341= AttrCalc()
      self.obj341.Copy=ATOM3Boolean()
      self.obj341.Copy.setValue(('Copy from LHS', 0))
      self.obj341.Copy.config = 0
      self.obj341.Specify=ATOM3Constraint()
      self.obj341.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'return self.getMatched(graphID, self.LHS.nodeWithLabel(1)).name.getValue()\n\n\n\n\n\n'))
      self.obj34.GGset2Any['name']= self.obj341
      self.RHS.addNode(self.obj34)

      self.obj35=GenericGraphEdge(parent)

      self.obj35.GGLabel.setValue(3)
      self.obj35.graphClass_= graph_GenericGraphEdge
      if parent.genGraphics:
         from graph_GenericGraphEdge import *
         new_obj = graph_GenericGraphEdge(172.0,163.0,self.obj35)
      else: new_obj = None
      self.obj35.graphObject_ = new_obj
      self.RHS.addNode(self.obj35)
      self.obj34.out_connections_.append(self.obj35)
      self.obj35.in_connections_.append(self.obj34)
      self.obj34.graphObject_.pendingConnections.append((self.obj34.graphObject_.tag, self.obj35.graphObject_.tag, [138.0, 201.0, 172.00000000000009, 163.0], 2, 0))
      self.obj35.out_connections_.append(self.obj33)
      self.obj33.in_connections_.append(self.obj35)
      self.obj35.graphObject_.pendingConnections.append((self.obj35.graphObject_.tag, self.obj33.graphObject_.tag, [210.0, 120.99999999999997, 172.00000000000009, 163.0], 2, 0))
   def condition(self, graphID, isograph, atom3i):
      node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      return not node.vehiclesPNPlaceGenerated
      
      
      
      
      
      
      
      
      

   def action(self, graphID, isograph, atom3i):
      self.getMatched(graphID, self.LHS.nodeWithLabel(1)).vehiclesPNPlaceGenerated=True
      

