# _ RoadSegment2Place.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from RoadSection import *
from ASG_Traffic import *
from Capacity import *
from Source2Section import *
from CapacityOf import *
from FlowTo import *
from Source import *
from Sink import *
from Section2Sink import *
from GenericGraphNode import *
from ASG_PetriNets import *
from tran2pl import *
from PNPlace import *
from ASG_GenericGraph import *
from pl2tran import *
from GenericGraphEdge import *
from PNTransition import *
class RoadSegment2Place (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 1)
      self.TimeDelay = ATOM3Integer(2)
      self.exactMatch = 1
      self.LHS = ASG_Traffic(parent)

      self.obj28=RoadSection(parent)

      self.obj28.num_vehicles.setNone()
      self.obj28.name.setValue('')
      self.obj28.GGLabel.setValue(1)
      self.obj28.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(187.0,159.0,self.obj28)
      else: new_obj = None
      self.obj28.graphObject_ = new_obj
      self.LHS.addNode(self.obj28)
      self.RHS = ASG_Traffic(parent)
      self.RHS.merge(ASG_PetriNets(parent))
      self.RHS.merge(ASG_GenericGraph(parent))

      self.obj92=RoadSection(parent)

      self.obj92.num_vehicles.setValue(0)
      self.obj92.name.setValue('')
      self.obj92.GGLabel.setValue(1)
      self.obj92.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(170.0,108.0,self.obj92)
      else: new_obj = None
      self.obj92.graphObject_ = new_obj
      self.obj920= AttrCalc()
      self.obj920.Copy=ATOM3Boolean()
      self.obj920.Copy.setValue(('Copy from LHS', 1))
      self.obj920.Copy.config = 0
      self.obj920.Specify=ATOM3Constraint()
      self.obj920.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj92.GGset2Any['num_vehicles']= self.obj920
      self.obj921= AttrCalc()
      self.obj921.Copy=ATOM3Boolean()
      self.obj921.Copy.setValue(('Copy from LHS', 1))
      self.obj921.Copy.config = 0
      self.obj921.Specify=ATOM3Constraint()
      self.obj921.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj92.GGset2Any['name']= self.obj921
      self.RHS.addNode(self.obj92)

      self.obj31=PNPlace(parent)

      self.obj31.tokens.setValue(0)
      self.obj31.name.setValue('0')
      self.obj31.GGLabel.setValue(2)
      self.obj31.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(312.0,202.0,self.obj31)
      else: new_obj = None
      self.obj31.graphObject_ = new_obj
      self.obj310= AttrCalc()
      self.obj310.Copy=ATOM3Boolean()
      self.obj310.Copy.setValue(('Copy from LHS', 0))
      self.obj310.Copy.config = 0
      self.obj310.Specify=ATOM3Constraint()
      self.obj310.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj31.GGset2Any['tokens']= self.obj310
      self.obj311= AttrCalc()
      self.obj311.Copy=ATOM3Boolean()
      self.obj311.Copy.setValue(('Copy from LHS', 0))
      self.obj311.Copy.config = 0
      self.obj311.Specify=ATOM3Constraint()
      self.obj311.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj31.GGset2Any['name']= self.obj311
      self.RHS.addNode(self.obj31)

      self.obj101=GenericGraphEdge(parent)

      self.obj101.GGLabel.setValue(3)
      self.obj101.graphClass_= graph_GenericGraphEdge
      if parent.genGraphics:
         from graph_GenericGraphEdge import *
         new_obj = graph_GenericGraphEdge(262.0,170.0,self.obj101)
      else: new_obj = None
      self.obj101.graphObject_ = new_obj
      self.RHS.addNode(self.obj101)
      self.obj31.out_connections_.append(self.obj101)
      self.obj101.in_connections_.append(self.obj31)
      self.obj31.graphObject_.pendingConnections.append((self.obj31.graphObject_.tag, self.obj101.graphObject_.tag, [320.0, 219.0, 262.00000000000011, 170.0], 2, 0))
      self.obj101.out_connections_.append(self.obj92)
      self.obj92.in_connections_.append(self.obj101)
      self.obj101.graphObject_.pendingConnections.append((self.obj101.graphObject_.tag, self.obj92.graphObject_.tag, [210.0, 121.0, 262.00000000000011, 170.0], 2, 0))
   def condition(self, graphID, isograph, atom3i):
      return 1
      

   def action(self, graphID, isograph, atom3i):
      pass

