# _ Capacity2PNPlace.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from RoadSection import *
from ASG_Traffic import *
from Capacity import *
from ASG_PetriNets import *
from Source2Section import *
from tran2pl import *
from CapacityOf import *
from FlowTo import *
from PNPlace import *
from Source import *
from Sink import *
from Section2Sink import *
from pl2tran import *
from PNTransition import *
from GenericGraphNode import *
from ASG_GenericGraph import *
from GenericGraphEdge import *
class Capacity2PNPlace (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 3)
      self.TimeDelay = ATOM3Integer(2)
      self.exactMatch = 1
      self.LHS = ASG_Traffic(parent)
      self.LHS.merge(ASG_PetriNets(parent))

      self.obj66=Capacity(parent)

      self.obj66.capacity.setNone()
      self.obj66.name.setValue('')
      self.obj66.GGLabel.setValue(1)
      self.obj66.graphClass_= graph_Capacity
      if parent.genGraphics:
         from graph_Capacity import *
         new_obj = graph_Capacity(161.0,193.0,self.obj66)
      else: new_obj = None
      self.obj66.graphObject_ = new_obj
      self.LHS.addNode(self.obj66)
      self.RHS = ASG_Traffic(parent)
      self.RHS.merge(ASG_PetriNets(parent))
      self.RHS.merge(ASG_GenericGraph(parent))

      self.obj70=Capacity(parent)

      self.obj70.capacity.setValue(0)
      self.obj70.name.setValue('')
      self.obj70.GGLabel.setValue(1)
      self.obj70.graphClass_= graph_Capacity
      if parent.genGraphics:
         from graph_Capacity import *
         new_obj = graph_Capacity(122.0,162.0,self.obj70)
      else: new_obj = None
      self.obj70.graphObject_ = new_obj
      self.obj700= AttrCalc()
      self.obj700.Copy=ATOM3Boolean()
      self.obj700.Copy.setValue(('Copy from LHS', 1))
      self.obj700.Copy.config = 0
      self.obj700.Specify=ATOM3Constraint()
      self.obj700.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj70.GGset2Any['capacity']= self.obj700
      self.obj701= AttrCalc()
      self.obj701.Copy=ATOM3Boolean()
      self.obj701.Copy.setValue(('Copy from LHS', 1))
      self.obj701.Copy.config = 0
      self.obj701.Specify=ATOM3Constraint()
      self.obj701.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj70.GGset2Any['name']= self.obj701
      self.RHS.addNode(self.obj70)

      self.obj71=PNPlace(parent)

      self.obj71.tokens.setValue(0)
      self.obj71.name.setValue('0')
      self.obj71.GGLabel.setValue(2)
      self.obj71.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(309.0,156.0,self.obj71)
      else: new_obj = None
      self.obj71.graphObject_ = new_obj
      self.obj710= AttrCalc()
      self.obj710.Copy=ATOM3Boolean()
      self.obj710.Copy.setValue(('Copy from LHS', 0))
      self.obj710.Copy.config = 0
      self.obj710.Specify=ATOM3Constraint()
      self.obj710.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'return self.getMatched(graphID, self.LHS.nodeWithLabel(1)).capacity.getValue()\n\n\n'))
      self.obj71.GGset2Any['tokens']= self.obj710
      self.obj711= AttrCalc()
      self.obj711.Copy=ATOM3Boolean()
      self.obj711.Copy.setValue(('Copy from LHS', 0))
      self.obj711.Copy.config = 0
      self.obj711.Specify=ATOM3Constraint()
      self.obj711.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'return self.getMatched(graphID, self.LHS.nodeWithLabel(1)).name.getValue()\n\n\n'))
      self.obj71.GGset2Any['name']= self.obj711
      self.RHS.addNode(self.obj71)

      self.obj72=GenericGraphEdge(parent)

      self.obj72.GGLabel.setValue(3)
      self.obj72.graphClass_= graph_GenericGraphEdge
      if parent.genGraphics:
         from graph_GenericGraphEdge import *
         new_obj = graph_GenericGraphEdge(236.0,173.0,self.obj72)
      else: new_obj = None
      self.obj72.graphObject_ = new_obj
      self.RHS.addNode(self.obj72)
      self.obj71.out_connections_.append(self.obj72)
      self.obj72.in_connections_.append(self.obj71)
      self.obj71.graphObject_.pendingConnections.append((self.obj71.graphObject_.tag, self.obj72.graphObject_.tag, [317.0, 173.0, 235.99999999999994, 172.99999999999989], 2, 0))
      self.obj72.out_connections_.append(self.obj70)
      self.obj70.in_connections_.append(self.obj72)
      self.obj72.graphObject_.pendingConnections.append((self.obj72.graphObject_.tag, self.obj70.graphObject_.tag, [155.0, 173.0, 235.99999999999994, 172.99999999999989], 2, 0))
   def condition(self, graphID, isograph, atom3i):
      inconn = self.getMatched( graphID, self.LHS.nodeWithLabel(1)).in_connections_
      return inconn == []
      
      
      

   def action(self, graphID, isograph, atom3i):
      self.getMatched( graphID, self.RHS.nodeWithLabel(1)).capacityPNPlaceGenerated = True
      
      
      

