# _ InitialCapacity.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from RoadSection import *
from ASG_Traffic import *
from Capacity import *
from ASG_PetriNets import *
from Source2Section import *
from tran2pl import *
from CapacityOf import *
from FlowTo import *
from PNPlace import *
from Source import *
from Sink import *
from Section2Sink import *
from pl2tran import *
from PNTransition import *
class InitialCapacity (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 8)
      self.TimeDelay = ATOM3Integer(2)
      self.exactMatch = 1
      self.LHS = ASG_Traffic(parent)
      self.LHS.merge(ASG_PetriNets(parent))

      self.obj126=RoadSection(parent)

      self.obj126.num_vehicles.setNone()
      self.obj126.name.setValue('')
      self.obj126.GGLabel.setValue(1)
      self.obj126.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(101.0,102.0,self.obj126)
      else: new_obj = None
      self.obj126.graphObject_ = new_obj
      self.LHS.addNode(self.obj126)

      self.obj127=CapacityOf(parent)

      self.obj127.GGLabel.setValue(3)
      self.obj127.graphClass_= graph_CapacityOf
      if parent.genGraphics:
         from graph_CapacityOf import *
         new_obj = graph_CapacityOf(234.0,115.0,self.obj127)
      else: new_obj = None
      self.obj127.graphObject_ = new_obj
      self.LHS.addNode(self.obj127)

      self.obj128=PNPlace(parent)

      self.obj128.tokens.setNone()
      self.obj128.name.setValue('')
      self.obj128.GGLabel.setValue(2)
      self.obj128.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(305.0,98.0,self.obj128)
      else: new_obj = None
      self.obj128.graphObject_ = new_obj
      self.LHS.addNode(self.obj128)
      self.obj127.out_connections_.append(self.obj126)
      self.obj126.in_connections_.append(self.obj127)
      self.obj127.graphObject_.pendingConnections.append((self.obj127.graphObject_.tag, self.obj126.graphObject_.tag, [141.0, 114.99999999999997, 233.99999999999994, 114.99999999999997], 2, 0))
      self.obj128.out_connections_.append(self.obj127)
      self.obj127.in_connections_.append(self.obj128)
      self.obj128.graphObject_.pendingConnections.append((self.obj128.graphObject_.tag, self.obj127.graphObject_.tag, [313.0, 114.99999999999997, 233.99999999999994, 114.99999999999997], 2, 0))
      self.RHS = ASG_Traffic(parent)
      self.RHS.merge(ASG_PetriNets(parent))

      self.obj131=RoadSection(parent)

      self.obj131.num_vehicles.setValue(0)
      self.obj131.name.setValue('')
      self.obj131.GGLabel.setValue(1)
      self.obj131.graphClass_= graph_RoadSection
      if parent.genGraphics:
         from graph_RoadSection import *
         new_obj = graph_RoadSection(110.0,125.0,self.obj131)
      else: new_obj = None
      self.obj131.graphObject_ = new_obj
      self.obj1310= AttrCalc()
      self.obj1310.Copy=ATOM3Boolean()
      self.obj1310.Copy.setValue(('Copy from LHS', 1))
      self.obj1310.Copy.config = 0
      self.obj1310.Specify=ATOM3Constraint()
      self.obj1310.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj131.GGset2Any['num_vehicles']= self.obj1310
      self.obj1311= AttrCalc()
      self.obj1311.Copy=ATOM3Boolean()
      self.obj1311.Copy.setValue(('Copy from LHS', 1))
      self.obj1311.Copy.config = 0
      self.obj1311.Specify=ATOM3Constraint()
      self.obj1311.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj131.GGset2Any['name']= self.obj1311
      self.RHS.addNode(self.obj131)

      self.obj132=PNPlace(parent)

      self.obj132.tokens.setValue(0)
      self.obj132.name.setValue('0')
      self.obj132.GGLabel.setValue(2)
      self.obj132.graphClass_= graph_PNPlace
      if parent.genGraphics:
         from graph_PNPlace import *
         new_obj = graph_PNPlace(309.0,115.0,self.obj132)
      else: new_obj = None
      self.obj132.graphObject_ = new_obj
      self.obj1320= AttrCalc()
      self.obj1320.Copy=ATOM3Boolean()
      self.obj1320.Copy.setValue(('Copy from LHS', 0))
      self.obj1320.Copy.config = 0
      self.obj1320.Specify=ATOM3Constraint()
      self.obj1320.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'initial_num_vehicles = self.getMatched(graphID, self.LHS.nodeWithLabel(1)).num_vehicles.getValue()\ncapacity_tokens = self.getMatched(graphID, self.LHS.nodeWithLabel(2)).tokens.getValue()\nreturn capacity_tokens-initial_num_vehicles\n\n\n\n\n\n\n'))
      self.obj132.GGset2Any['tokens']= self.obj1320
      self.obj1321= AttrCalc()
      self.obj1321.Copy=ATOM3Boolean()
      self.obj1321.Copy.setValue(('Copy from LHS', 1))
      self.obj1321.Copy.config = 0
      self.obj1321.Specify=ATOM3Constraint()
      self.obj1321.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
      self.obj132.GGset2Any['name']= self.obj1321
      self.RHS.addNode(self.obj132)
   def condition(self, graphID, isograph, atom3i):
      # note that the number of capacity tokens should never become <= 0
      return 1
      
      

   def action(self, graphID, isograph, atom3i):
      pass

