from GraphGrammarEdit import *
from GGruleEdit import *

def savedTrans(self):
   self.EditingGraphGrammar= GraphGrammarEdit(None, self)
   self.EditingGraphGrammar.Name=ATOM3String('Traffic2PN')
   self.EditingGraphGrammar.Rules=ATOM3List([ 1, 1, 1, 0],GGruleEdit,None, self)
   lcobj0=[]
   cobj0= GGruleEdit(None, self)
   cobj0.Name=ATOM3String('RoadSection2PNPlace')
   cobj0.Order=ATOM3Integer(1)
   cobj0.TimeDelay=ATOM3Integer(2)
   cobj0.SubtypesMatching=ATOM3Boolean()
   cobj0.SubtypesMatching.setValue((None, 0))
   cobj0.SubtypesMatching.config = 0

   from RoadSection import *
   from ASG_Traffic import *
   from Capacity import *
   from Source2Section import *
   from CapacityOf import *
   from FlowTo import *
   from Source import *
   from Sink import *
   from Section2Sink import *
   from GenericGraphNode import *
   from ASG_PetriNets import *
   from tran2pl import *
   from PNPlace import *
   from ASG_GenericGraph import *
   from pl2tran import *
   from GenericGraphEdge import *
   from PNTransition import *

   cobj0.LHS = ASG_Traffic(self)

   self.obj29=RoadSection(self)

   self.obj29.num_vehicles.setNone()
   self.obj29.name.setValue('')
   self.obj29.GGLabel.setValue(1)
   self.obj29.graphClass_= graph_RoadSection
   if self.genGraphics:
      from graph_RoadSection import *
      new_obj = graph_RoadSection(187.0,159.0,self.obj29)
   else: new_obj = None
   self.obj29.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj29)
   cobj0.RHS = ASG_Traffic(self)
   cobj0.RHS.merge(ASG_PetriNets(self))
   cobj0.RHS.merge(ASG_GenericGraph(self))

   self.obj33=RoadSection(self)

   self.obj33.num_vehicles.setValue(0)
   self.obj33.name.setValue('')
   self.obj33.GGLabel.setValue(1)
   self.obj33.graphClass_= graph_RoadSection
   if self.genGraphics:
      from graph_RoadSection import *
      new_obj = graph_RoadSection(170.0,108.0,self.obj33)
   else: new_obj = None
   self.obj33.graphObject_ = new_obj
   self.obj330= AttrCalc()
   self.obj330.Copy=ATOM3Boolean()
   self.obj330.Copy.setValue(('Copy from LHS', 1))
   self.obj330.Copy.config = 0
   self.obj330.Specify=ATOM3Constraint()
   self.obj330.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj33.GGset2Any['num_vehicles']= self.obj330
   self.obj331= AttrCalc()
   self.obj331.Copy=ATOM3Boolean()
   self.obj331.Copy.setValue(('Copy from LHS', 1))
   self.obj331.Copy.config = 0
   self.obj331.Specify=ATOM3Constraint()
   self.obj331.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj33.GGset2Any['name']= self.obj331
   cobj0.RHS.addNode(self.obj33)

   self.obj34=PNPlace(self)

   self.obj34.tokens.setValue(0)
   self.obj34.name.setValue('0')
   self.obj34.GGLabel.setValue(2)
   self.obj34.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(114.0,198.0,self.obj34)
   else: new_obj = None
   self.obj34.graphObject_ = new_obj
   self.obj340= AttrCalc()
   self.obj340.Copy=ATOM3Boolean()
   self.obj340.Copy.setValue(('Copy from LHS', 0))
   self.obj340.Copy.config = 0
   self.obj340.Specify=ATOM3Constraint()
   self.obj340.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'return self.getMatched(graphID, self.LHS.nodeWithLabel(1)).num_vehicles.getValue()\n\n\n\n'))
   self.obj34.GGset2Any['tokens']= self.obj340
   self.obj341= AttrCalc()
   self.obj341.Copy=ATOM3Boolean()
   self.obj341.Copy.setValue(('Copy from LHS', 0))
   self.obj341.Copy.config = 0
   self.obj341.Specify=ATOM3Constraint()
   self.obj341.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'return self.getMatched(graphID, self.LHS.nodeWithLabel(1)).name.getValue()\n\n\n\n\n\n'))
   self.obj34.GGset2Any['name']= self.obj341
   cobj0.RHS.addNode(self.obj34)

   self.obj35=GenericGraphEdge(self)

   self.obj35.GGLabel.setValue(3)
   self.obj35.graphClass_= graph_GenericGraphEdge
   if self.genGraphics:
      from graph_GenericGraphEdge import *
      new_obj = graph_GenericGraphEdge(172.0,163.0,self.obj35)
   else: new_obj = None
   self.obj35.graphObject_ = new_obj
   cobj0.RHS.addNode(self.obj35)
   self.obj34.out_connections_.append(self.obj35)
   self.obj35.in_connections_.append(self.obj34)
   self.obj34.graphObject_.pendingConnections.append((self.obj34.graphObject_.tag, self.obj35.graphObject_.tag, [138.0, 201.0, 172.00000000000009, 163.0], 2, 0))
   self.obj35.out_connections_.append(self.obj33)
   self.obj33.in_connections_.append(self.obj35)
   self.obj35.graphObject_.pendingConnections.append((self.obj35.graphObject_.tag, self.obj33.graphObject_.tag, [210.0, 120.99999999999997, 172.00000000000009, 163.0], 2, 0))
   cobj0.Condition=ATOM3Constraint()
   cobj0.Condition.setValue(('condition', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))\nreturn not node.vehiclesPNPlaceGenerated\n\n\n\n\n\n\n\n\n'))
   cobj0.Action=ATOM3Constraint()
   cobj0.Action.setValue(('action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'self.getMatched(graphID, self.LHS.nodeWithLabel(1)).vehiclesPNPlaceGenerated=True\n'))
   lcobj0.append(cobj0)
   cobj0= GGruleEdit(None, self)
   cobj0.Name=ATOM3String('FlowTo2PNTransition')
   cobj0.Order=ATOM3Integer(2)
   cobj0.TimeDelay=ATOM3Integer(2)
   cobj0.SubtypesMatching=ATOM3Boolean()
   cobj0.SubtypesMatching.setValue((None, 0))
   cobj0.SubtypesMatching.config = 0

   from RoadSection import *
   from ASG_Traffic import *
   from Capacity import *
   from GenericGraphNode import *
   from ASG_PetriNets import *
   from Source2Section import *
   from tran2pl import *
   from CapacityOf import *
   from FlowTo import *
   from PNPlace import *
   from Source import *
   from Sink import *
   from ASG_GenericGraph import *
   from Section2Sink import *
   from pl2tran import *
   from GenericGraphEdge import *
   from PNTransition import *

   cobj0.LHS = ASG_Traffic(self)
   cobj0.LHS.merge(ASG_PetriNets(self))
   cobj0.LHS.merge(ASG_GenericGraph(self))

   self.obj42=RoadSection(self)

   self.obj42.num_vehicles.setNone()
   self.obj42.name.setValue('')
   self.obj42.GGLabel.setValue(1)
   self.obj42.graphClass_= graph_RoadSection
   if self.genGraphics:
      from graph_RoadSection import *
      new_obj = graph_RoadSection(210.0,159.0,self.obj42)
   else: new_obj = None
   self.obj42.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj42)

   self.obj43=RoadSection(self)

   self.obj43.num_vehicles.setNone()
   self.obj43.name.setValue('')
   self.obj43.GGLabel.setValue(2)
   self.obj43.graphClass_= graph_RoadSection
   if self.genGraphics:
      from graph_RoadSection import *
      new_obj = graph_RoadSection(364.0,158.0,self.obj43)
   else: new_obj = None
   self.obj43.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj43)

   self.obj44=FlowTo(self)

   self.obj44.GGLabel.setValue(7)
   self.obj44.graphClass_= graph_FlowTo
   if self.genGraphics:
      from graph_FlowTo import *
      new_obj = graph_FlowTo(323.5,171.5,self.obj44)
   else: new_obj = None
   self.obj44.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj44)

   self.obj45=PNPlace(self)

   self.obj45.tokens.setNone()
   self.obj45.name.setValue('')
   self.obj45.GGLabel.setValue(3)
   self.obj45.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(159.0,236.0,self.obj45)
   else: new_obj = None
   self.obj45.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj45)

   self.obj46=PNPlace(self)

   self.obj46.tokens.setNone()
   self.obj46.name.setValue('')
   self.obj46.GGLabel.setValue(4)
   self.obj46.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(335.0,237.0,self.obj46)
   else: new_obj = None
   self.obj46.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj46)

   self.obj47=GenericGraphEdge(self)

   self.obj47.GGLabel.setValue(5)
   self.obj47.graphClass_= graph_GenericGraphEdge
   if self.genGraphics:
      from graph_GenericGraphEdge import *
      new_obj = graph_GenericGraphEdge(216.0,206.0,self.obj47)
   else: new_obj = None
   self.obj47.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj47)

   self.obj48=GenericGraphEdge(self)

   self.obj48.GGLabel.setValue(6)
   self.obj48.graphClass_= graph_GenericGraphEdge
   if self.genGraphics:
      from graph_GenericGraphEdge import *
      new_obj = graph_GenericGraphEdge(383.0,206.0,self.obj48)
   else: new_obj = None
   self.obj48.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj48)
   self.obj42.out_connections_.append(self.obj44)
   self.obj44.in_connections_.append(self.obj42)
   self.obj42.graphObject_.pendingConnections.append((self.obj42.graphObject_.tag, self.obj44.graphObject_.tag, [249.99999999999986, 172.0, 323.50000000000017, 171.49999999999969], 2, 0))
   self.obj44.out_connections_.append(self.obj43)
   self.obj43.in_connections_.append(self.obj44)
   self.obj44.graphObject_.pendingConnections.append((self.obj44.graphObject_.tag, self.obj43.graphObject_.tag, [404.00000000000023, 171.0, 323.50000000000017, 171.49999999999969], 2, 0))
   self.obj45.out_connections_.append(self.obj47)
   self.obj47.in_connections_.append(self.obj45)
   self.obj45.graphObject_.pendingConnections.append((self.obj45.graphObject_.tag, self.obj47.graphObject_.tag, [183.0, 239.00000000000003, 216.0, 206.0], 2, 0))
   self.obj46.out_connections_.append(self.obj48)
   self.obj48.in_connections_.append(self.obj46)
   self.obj46.graphObject_.pendingConnections.append((self.obj46.graphObject_.tag, self.obj48.graphObject_.tag, [359.00000000000017, 239.99999999999994, 383.00000000000006, 205.99999999999994], 2, 0))
   self.obj47.out_connections_.append(self.obj42)
   self.obj42.in_connections_.append(self.obj47)
   self.obj47.graphObject_.pendingConnections.append((self.obj47.graphObject_.tag, self.obj42.graphObject_.tag, [249.99999999999986, 172.0, 216.0, 206.0], 2, 0))
   self.obj48.out_connections_.append(self.obj43)
   self.obj43.in_connections_.append(self.obj48)
   self.obj48.graphObject_.pendingConnections.append((self.obj48.graphObject_.tag, self.obj43.graphObject_.tag, [404.00000000000023, 171.0, 383.00000000000006, 205.99999999999994], 2, 0))
   cobj0.RHS = ASG_Traffic(self)
   cobj0.RHS.merge(ASG_PetriNets(self))
   cobj0.RHS.merge(ASG_GenericGraph(self))

   self.obj52=RoadSection(self)

   self.obj52.num_vehicles.setValue(0)
   self.obj52.name.setValue('')
   self.obj52.GGLabel.setValue(1)
   self.obj52.graphClass_= graph_RoadSection
   if self.genGraphics:
      from graph_RoadSection import *
      new_obj = graph_RoadSection(197.0,133.0,self.obj52)
   else: new_obj = None
   self.obj52.graphObject_ = new_obj
   self.obj520= AttrCalc()
   self.obj520.Copy=ATOM3Boolean()
   self.obj520.Copy.setValue(('Copy from LHS', 1))
   self.obj520.Copy.config = 0
   self.obj520.Specify=ATOM3Constraint()
   self.obj520.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj52.GGset2Any['num_vehicles']= self.obj520
   self.obj521= AttrCalc()
   self.obj521.Copy=ATOM3Boolean()
   self.obj521.Copy.setValue(('Copy from LHS', 1))
   self.obj521.Copy.config = 0
   self.obj521.Specify=ATOM3Constraint()
   self.obj521.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj52.GGset2Any['name']= self.obj521
   cobj0.RHS.addNode(self.obj52)

   self.obj53=RoadSection(self)

   self.obj53.num_vehicles.setValue(0)
   self.obj53.name.setValue('')
   self.obj53.GGLabel.setValue(2)
   self.obj53.graphClass_= graph_RoadSection
   if self.genGraphics:
      from graph_RoadSection import *
      new_obj = graph_RoadSection(415.0,131.0,self.obj53)
   else: new_obj = None
   self.obj53.graphObject_ = new_obj
   self.obj530= AttrCalc()
   self.obj530.Copy=ATOM3Boolean()
   self.obj530.Copy.setValue(('Copy from LHS', 1))
   self.obj530.Copy.config = 0
   self.obj530.Specify=ATOM3Constraint()
   self.obj530.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj53.GGset2Any['num_vehicles']= self.obj530
   self.obj531= AttrCalc()
   self.obj531.Copy=ATOM3Boolean()
   self.obj531.Copy.setValue(('Copy from LHS', 1))
   self.obj531.Copy.config = 0
   self.obj531.Specify=ATOM3Constraint()
   self.obj531.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj53.GGset2Any['name']= self.obj531
   cobj0.RHS.addNode(self.obj53)

   self.obj54=PNPlace(self)

   self.obj54.tokens.setValue(0)
   self.obj54.name.setValue('0')
   self.obj54.GGLabel.setValue(3)
   self.obj54.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(171.0,217.0,self.obj54)
   else: new_obj = None
   self.obj54.graphObject_ = new_obj
   self.obj540= AttrCalc()
   self.obj540.Copy=ATOM3Boolean()
   self.obj540.Copy.setValue(('Copy from LHS', 1))
   self.obj540.Copy.config = 0
   self.obj540.Specify=ATOM3Constraint()
   self.obj540.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj54.GGset2Any['tokens']= self.obj540
   self.obj541= AttrCalc()
   self.obj541.Copy=ATOM3Boolean()
   self.obj541.Copy.setValue(('Copy from LHS', 1))
   self.obj541.Copy.config = 0
   self.obj541.Specify=ATOM3Constraint()
   self.obj541.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj54.GGset2Any['name']= self.obj541
   cobj0.RHS.addNode(self.obj54)

   self.obj55=PNPlace(self)

   self.obj55.tokens.setValue(0)
   self.obj55.name.setValue('1')
   self.obj55.GGLabel.setValue(4)
   self.obj55.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(387.0,216.0,self.obj55)
   else: new_obj = None
   self.obj55.graphObject_ = new_obj
   self.obj550= AttrCalc()
   self.obj550.Copy=ATOM3Boolean()
   self.obj550.Copy.setValue(('Copy from LHS', 1))
   self.obj550.Copy.config = 0
   self.obj550.Specify=ATOM3Constraint()
   self.obj550.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj55.GGset2Any['tokens']= self.obj550
   self.obj551= AttrCalc()
   self.obj551.Copy=ATOM3Boolean()
   self.obj551.Copy.setValue(('Copy from LHS', 1))
   self.obj551.Copy.config = 0
   self.obj551.Specify=ATOM3Constraint()
   self.obj551.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj55.GGset2Any['name']= self.obj551
   cobj0.RHS.addNode(self.obj55)

   self.obj56=pl2tran(self)

   self.obj56.weight.setValue(1)
   self.obj56.GGLabel.setValue(9)
   self.obj56.graphClass_= graph_pl2tran
   if self.genGraphics:
      from graph_pl2tran import *
      new_obj = graph_pl2tran(268.5,234.5,self.obj56)
   else: new_obj = None
   self.obj56.graphObject_ = new_obj
   self.obj560= AttrCalc()
   self.obj560.Copy=ATOM3Boolean()
   self.obj560.Copy.setValue(('Copy from LHS', 0))
   self.obj560.Copy.config = 0
   self.obj560.Specify=ATOM3Constraint()
   self.obj560.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj56.GGset2Any['weight']= self.obj560
   cobj0.RHS.addNode(self.obj56)

   self.obj57=PNTransition(self)

   self.obj57.name.setValue('0')
   self.obj57.GGLabel.setValue(8)
   self.obj57.graphClass_= graph_PNTransition
   if self.genGraphics:
      from graph_PNTransition import *
      new_obj = graph_PNTransition(273.0,283.0,self.obj57)
   else: new_obj = None
   self.obj57.graphObject_ = new_obj
   self.obj570= AttrCalc()
   self.obj570.Copy=ATOM3Boolean()
   self.obj570.Copy.setValue(('Copy from LHS', 0))
   self.obj570.Copy.config = 0
   self.obj570.Specify=ATOM3Constraint()
   self.obj570.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj57.GGset2Any['name']= self.obj570
   cobj0.RHS.addNode(self.obj57)

   self.obj58=tran2pl(self)

   self.obj58.weight.setValue(1)
   self.obj58.GGLabel.setValue(10)
   self.obj58.graphClass_= graph_tran2pl
   if self.genGraphics:
      from graph_tran2pl import *
      new_obj = graph_tran2pl(339.5,233.0,self.obj58)
   else: new_obj = None
   self.obj58.graphObject_ = new_obj
   self.obj580= AttrCalc()
   self.obj580.Copy=ATOM3Boolean()
   self.obj580.Copy.setValue(('Copy from LHS', 0))
   self.obj580.Copy.config = 0
   self.obj580.Specify=ATOM3Constraint()
   self.obj580.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj58.GGset2Any['weight']= self.obj580
   cobj0.RHS.addNode(self.obj58)

   self.obj59=GenericGraphEdge(self)

   self.obj59.GGLabel.setValue(5)
   self.obj59.graphClass_= graph_GenericGraphEdge
   if self.genGraphics:
      from graph_GenericGraphEdge import *
      new_obj = graph_GenericGraphEdge(217.0,182.0,self.obj59)
   else: new_obj = None
   self.obj59.graphObject_ = new_obj
   cobj0.RHS.addNode(self.obj59)

   self.obj60=GenericGraphEdge(self)

   self.obj60.GGLabel.setValue(6)
   self.obj60.graphClass_= graph_GenericGraphEdge
   if self.genGraphics:
      from graph_GenericGraphEdge import *
      new_obj = graph_GenericGraphEdge(433.0,184.0,self.obj60)
   else: new_obj = None
   self.obj60.graphObject_ = new_obj
   cobj0.RHS.addNode(self.obj60)
   self.obj54.out_connections_.append(self.obj59)
   self.obj59.in_connections_.append(self.obj54)
   self.obj54.graphObject_.pendingConnections.append((self.obj54.graphObject_.tag, self.obj59.graphObject_.tag, [195.00000000000003, 219.99999999999994, 217.0, 182.0], 2, 0))
   self.obj54.out_connections_.append(self.obj56)
   self.obj56.in_connections_.append(self.obj54)
   self.obj54.graphObject_.pendingConnections.append((self.obj54.graphObject_.tag, self.obj56.graphObject_.tag, [213.0, 233.99999999999997, 268.5, 234.50000000000011], 2, 0))
   self.obj55.out_connections_.append(self.obj60)
   self.obj60.in_connections_.append(self.obj55)
   self.obj55.graphObject_.pendingConnections.append((self.obj55.graphObject_.tag, self.obj60.graphObject_.tag, [410.99999999999989, 218.99999999999994, 433.0, 184.0], 2, 0))
   self.obj56.out_connections_.append(self.obj57)
   self.obj57.in_connections_.append(self.obj56)
   self.obj56.graphObject_.pendingConnections.append((self.obj56.graphObject_.tag, self.obj57.graphObject_.tag, [305.99999999999994, 291.0, 268.5, 234.50000000000011], 2, 0))
   self.obj57.out_connections_.append(self.obj58)
   self.obj58.in_connections_.append(self.obj57)
   self.obj57.graphObject_.pendingConnections.append((self.obj57.graphObject_.tag, self.obj58.graphObject_.tag, [305.99999999999994, 291.0, 339.50000000000017, 232.99999999999997], 2, 0))
   self.obj58.out_connections_.append(self.obj55)
   self.obj55.in_connections_.append(self.obj58)
   self.obj58.graphObject_.pendingConnections.append((self.obj58.graphObject_.tag, self.obj55.graphObject_.tag, [395.0, 232.99999999999997, 339.50000000000017, 232.99999999999997], 2, 0))
   self.obj59.out_connections_.append(self.obj52)
   self.obj52.in_connections_.append(self.obj59)
   self.obj59.graphObject_.pendingConnections.append((self.obj59.graphObject_.tag, self.obj52.graphObject_.tag, [236.99999999999997, 146.0, 217.0, 182.0], 2, 0))
   self.obj60.out_connections_.append(self.obj53)
   self.obj53.in_connections_.append(self.obj60)
   self.obj60.graphObject_.pendingConnections.append((self.obj60.graphObject_.tag, self.obj53.graphObject_.tag, [455.00000000000006, 144.0, 433.0, 184.0], 2, 0))
   cobj0.Condition=ATOM3Constraint()
   cobj0.Condition.setValue(('condition', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'return 1\n'))
   cobj0.Action=ATOM3Constraint()
   cobj0.Action.setValue(('action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
   lcobj0.append(cobj0)
   cobj0= GGruleEdit(None, self)
   cobj0.Name=ATOM3String('Capacity2PNPlace')
   cobj0.Order=ATOM3Integer(3)
   cobj0.TimeDelay=ATOM3Integer(2)
   cobj0.SubtypesMatching=ATOM3Boolean()
   cobj0.SubtypesMatching.setValue((None, 0))
   cobj0.SubtypesMatching.config = 0

   from RoadSection import *
   from ASG_Traffic import *
   from Capacity import *
   from ASG_PetriNets import *
   from Source2Section import *
   from tran2pl import *
   from CapacityOf import *
   from FlowTo import *
   from PNPlace import *
   from Source import *
   from Sink import *
   from Section2Sink import *
   from pl2tran import *
   from PNTransition import *
   from GenericGraphNode import *
   from ASG_GenericGraph import *
   from GenericGraphEdge import *

   cobj0.LHS = ASG_Traffic(self)
   cobj0.LHS.merge(ASG_PetriNets(self))

   self.obj66=Capacity(self)

   self.obj66.capacity.setNone()
   self.obj66.name.setValue('')
   self.obj66.GGLabel.setValue(1)
   self.obj66.graphClass_= graph_Capacity
   if self.genGraphics:
      from graph_Capacity import *
      new_obj = graph_Capacity(161.0,193.0,self.obj66)
   else: new_obj = None
   self.obj66.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj66)
   cobj0.RHS = ASG_Traffic(self)
   cobj0.RHS.merge(ASG_PetriNets(self))
   cobj0.RHS.merge(ASG_GenericGraph(self))

   self.obj70=Capacity(self)

   self.obj70.capacity.setValue(0)
   self.obj70.name.setValue('')
   self.obj70.GGLabel.setValue(1)
   self.obj70.graphClass_= graph_Capacity
   if self.genGraphics:
      from graph_Capacity import *
      new_obj = graph_Capacity(122.0,162.0,self.obj70)
   else: new_obj = None
   self.obj70.graphObject_ = new_obj
   self.obj700= AttrCalc()
   self.obj700.Copy=ATOM3Boolean()
   self.obj700.Copy.setValue(('Copy from LHS', 1))
   self.obj700.Copy.config = 0
   self.obj700.Specify=ATOM3Constraint()
   self.obj700.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj70.GGset2Any['capacity']= self.obj700
   self.obj701= AttrCalc()
   self.obj701.Copy=ATOM3Boolean()
   self.obj701.Copy.setValue(('Copy from LHS', 1))
   self.obj701.Copy.config = 0
   self.obj701.Specify=ATOM3Constraint()
   self.obj701.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj70.GGset2Any['name']= self.obj701
   cobj0.RHS.addNode(self.obj70)

   self.obj71=PNPlace(self)

   self.obj71.tokens.setValue(0)
   self.obj71.name.setValue('0')
   self.obj71.GGLabel.setValue(2)
   self.obj71.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(309.0,156.0,self.obj71)
   else: new_obj = None
   self.obj71.graphObject_ = new_obj
   self.obj710= AttrCalc()
   self.obj710.Copy=ATOM3Boolean()
   self.obj710.Copy.setValue(('Copy from LHS', 0))
   self.obj710.Copy.config = 0
   self.obj710.Specify=ATOM3Constraint()
   self.obj710.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'return self.getMatched(graphID, self.LHS.nodeWithLabel(1)).capacity.getValue()\n\n\n'))
   self.obj71.GGset2Any['tokens']= self.obj710
   self.obj711= AttrCalc()
   self.obj711.Copy=ATOM3Boolean()
   self.obj711.Copy.setValue(('Copy from LHS', 0))
   self.obj711.Copy.config = 0
   self.obj711.Specify=ATOM3Constraint()
   self.obj711.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'return self.getMatched(graphID, self.LHS.nodeWithLabel(1)).name.getValue()\n\n\n'))
   self.obj71.GGset2Any['name']= self.obj711
   cobj0.RHS.addNode(self.obj71)

   self.obj72=GenericGraphEdge(self)

   self.obj72.GGLabel.setValue(3)
   self.obj72.graphClass_= graph_GenericGraphEdge
   if self.genGraphics:
      from graph_GenericGraphEdge import *
      new_obj = graph_GenericGraphEdge(236.0,173.0,self.obj72)
   else: new_obj = None
   self.obj72.graphObject_ = new_obj
   cobj0.RHS.addNode(self.obj72)
   self.obj71.out_connections_.append(self.obj72)
   self.obj72.in_connections_.append(self.obj71)
   self.obj71.graphObject_.pendingConnections.append((self.obj71.graphObject_.tag, self.obj72.graphObject_.tag, [317.0, 173.0, 235.99999999999994, 172.99999999999989], 2, 0))
   self.obj72.out_connections_.append(self.obj70)
   self.obj70.in_connections_.append(self.obj72)
   self.obj72.graphObject_.pendingConnections.append((self.obj72.graphObject_.tag, self.obj70.graphObject_.tag, [155.0, 173.0, 235.99999999999994, 172.99999999999989], 2, 0))
   cobj0.Condition=ATOM3Constraint()
   cobj0.Condition.setValue(('condition', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'inconn = self.getMatched( graphID, self.LHS.nodeWithLabel(1)).in_connections_\nreturn inconn == []\n\n\n'))
   cobj0.Action=ATOM3Constraint()
   cobj0.Action.setValue(('action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'self.getMatched( graphID, self.RHS.nodeWithLabel(1)).capacityPNPlaceGenerated = True\n\n\n'))
   lcobj0.append(cobj0)
   cobj0= GGruleEdit(None, self)
   cobj0.Name=ATOM3String('CapacityConstraintOnPl2Tr')
   cobj0.Order=ATOM3Integer(6)
   cobj0.TimeDelay=ATOM3Integer(2)
   cobj0.SubtypesMatching=ATOM3Boolean()
   cobj0.SubtypesMatching.setValue((None, 0))
   cobj0.SubtypesMatching.config = 0

   from RoadSection import *
   from ASG_Traffic import *
   from Capacity import *
   from GenericGraphNode import *
   from ASG_PetriNets import *
   from Source2Section import *
   from tran2pl import *
   from CapacityOf import *
   from FlowTo import *
   from PNPlace import *
   from Source import *
   from Sink import *
   from ASG_GenericGraph import *
   from Section2Sink import *
   from pl2tran import *
   from GenericGraphEdge import *
   from PNTransition import *

   cobj0.LHS = ASG_Traffic(self)
   cobj0.LHS.merge(ASG_PetriNets(self))
   cobj0.LHS.merge(ASG_GenericGraph(self))

   self.obj79=RoadSection(self)

   self.obj79.num_vehicles.setNone()
   self.obj79.name.setValue('')
   self.obj79.GGLabel.setValue(1)
   self.obj79.graphClass_= graph_RoadSection
   if self.genGraphics:
      from graph_RoadSection import *
      new_obj = graph_RoadSection(143.0,107.0,self.obj79)
   else: new_obj = None
   self.obj79.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj79)

   self.obj80=CapacityOf(self)

   self.obj80.GGLabel.setValue(7)
   self.obj80.graphClass_= graph_CapacityOf
   if self.genGraphics:
      from graph_CapacityOf import *
      new_obj = graph_CapacityOf(247.0,120.0,self.obj80)
   else: new_obj = None
   self.obj80.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj80)

   self.obj81=PNPlace(self)

   self.obj81.tokens.setNone()
   self.obj81.name.setValue('')
   self.obj81.GGLabel.setValue(2)
   self.obj81.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(159.0,218.0,self.obj81)
   else: new_obj = None
   self.obj81.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj81)

   self.obj82=PNPlace(self)

   self.obj82.tokens.setNone()
   self.obj82.name.setValue('')
   self.obj82.GGLabel.setValue(6)
   self.obj82.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(284.0,103.0,self.obj82)
   else: new_obj = None
   self.obj82.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj82)

   self.obj83=pl2tran(self)

   self.obj83.weight.setNone()
   self.obj83.GGLabel.setValue(5)
   self.obj83.graphClass_= graph_pl2tran
   if self.genGraphics:
      from graph_pl2tran import *
      new_obj = graph_pl2tran(260.5,234.5,self.obj83)
   else: new_obj = None
   self.obj83.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj83)

   self.obj84=PNTransition(self)

   self.obj84.name.setValue('')
   self.obj84.GGLabel.setValue(4)
   self.obj84.graphClass_= graph_PNTransition
   if self.genGraphics:
      from graph_PNTransition import *
      new_obj = graph_PNTransition(286.0,283.0,self.obj84)
   else: new_obj = None
   self.obj84.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj84)

   self.obj85=GenericGraphEdge(self)

   self.obj85.GGLabel.setValue(3)
   self.obj85.graphClass_= graph_GenericGraphEdge
   if self.genGraphics:
      from graph_GenericGraphEdge import *
      new_obj = graph_GenericGraphEdge(183.0,166.0,self.obj85)
   else: new_obj = None
   self.obj85.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj85)
   self.obj80.out_connections_.append(self.obj79)
   self.obj79.in_connections_.append(self.obj80)
   self.obj80.graphObject_.pendingConnections.append((self.obj80.graphObject_.tag, self.obj79.graphObject_.tag, [183.0, 119.99999999999997, 246.99999999999994, 119.99999999999997], 2, 0))
   self.obj81.out_connections_.append(self.obj83)
   self.obj83.in_connections_.append(self.obj81)
   self.obj81.graphObject_.pendingConnections.append((self.obj81.graphObject_.tag, self.obj83.graphObject_.tag, [201.0, 234.99999999999994, 260.49999999999994, 234.49999999999994], 2, 0))
   self.obj81.out_connections_.append(self.obj85)
   self.obj85.in_connections_.append(self.obj81)
   self.obj81.graphObject_.pendingConnections.append((self.obj81.graphObject_.tag, self.obj85.graphObject_.tag, [183.0, 220.99999999999994, 183.0, 166.0], 2, 0))
   self.obj82.out_connections_.append(self.obj80)
   self.obj80.in_connections_.append(self.obj82)
   self.obj82.graphObject_.pendingConnections.append((self.obj82.graphObject_.tag, self.obj80.graphObject_.tag, [292.0, 119.99999999999997, 246.99999999999994, 119.99999999999997], 2, 0))
   self.obj83.out_connections_.append(self.obj84)
   self.obj84.in_connections_.append(self.obj83)
   self.obj83.graphObject_.pendingConnections.append((self.obj83.graphObject_.tag, self.obj84.graphObject_.tag, [319.0, 291.0, 260.49999999999994, 234.49999999999994], 2, 0))
   self.obj85.out_connections_.append(self.obj79)
   self.obj79.in_connections_.append(self.obj85)
   self.obj85.graphObject_.pendingConnections.append((self.obj85.graphObject_.tag, self.obj79.graphObject_.tag, [183.0, 119.99999999999997, 183.0, 166.0], 2, 0))
   cobj0.RHS = ASG_Traffic(self)
   cobj0.RHS.merge(ASG_PetriNets(self))
   cobj0.RHS.merge(ASG_GenericGraph(self))

   self.obj89=RoadSection(self)

   self.obj89.num_vehicles.setValue(0)
   self.obj89.name.setValue('')
   self.obj89.GGLabel.setValue(1)
   self.obj89.graphClass_= graph_RoadSection
   if self.genGraphics:
      from graph_RoadSection import *
      new_obj = graph_RoadSection(143.0,107.0,self.obj89)
   else: new_obj = None
   self.obj89.graphObject_ = new_obj
   self.obj890= AttrCalc()
   self.obj890.Copy=ATOM3Boolean()
   self.obj890.Copy.setValue(('Copy from LHS', 1))
   self.obj890.Copy.config = 0
   self.obj890.Specify=ATOM3Constraint()
   self.obj890.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj89.GGset2Any['num_vehicles']= self.obj890
   self.obj891= AttrCalc()
   self.obj891.Copy=ATOM3Boolean()
   self.obj891.Copy.setValue(('Copy from LHS', 1))
   self.obj891.Copy.config = 0
   self.obj891.Specify=ATOM3Constraint()
   self.obj891.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj89.GGset2Any['name']= self.obj891
   cobj0.RHS.addNode(self.obj89)

   self.obj90=CapacityOf(self)

   self.obj90.GGLabel.setValue(7)
   self.obj90.graphClass_= graph_CapacityOf
   if self.genGraphics:
      from graph_CapacityOf import *
      new_obj = graph_CapacityOf(248.0,120.0,self.obj90)
   else: new_obj = None
   self.obj90.graphObject_ = new_obj
   cobj0.RHS.addNode(self.obj90)

   self.obj91=PNPlace(self)

   self.obj91.tokens.setValue(0)
   self.obj91.name.setValue('0')
   self.obj91.GGLabel.setValue(2)
   self.obj91.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(159.0,226.0,self.obj91)
   else: new_obj = None
   self.obj91.graphObject_ = new_obj
   self.obj910= AttrCalc()
   self.obj910.Copy=ATOM3Boolean()
   self.obj910.Copy.setValue(('Copy from LHS', 1))
   self.obj910.Copy.config = 0
   self.obj910.Specify=ATOM3Constraint()
   self.obj910.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj91.GGset2Any['tokens']= self.obj910
   self.obj911= AttrCalc()
   self.obj911.Copy=ATOM3Boolean()
   self.obj911.Copy.setValue(('Copy from LHS', 1))
   self.obj911.Copy.config = 0
   self.obj911.Specify=ATOM3Constraint()
   self.obj911.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj91.GGset2Any['name']= self.obj911
   cobj0.RHS.addNode(self.obj91)

   self.obj92=PNPlace(self)

   self.obj92.tokens.setNone()
   self.obj92.name.setValue('')
   self.obj92.GGLabel.setValue(6)
   self.obj92.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(289.0,103.0,self.obj92)
   else: new_obj = None
   self.obj92.graphObject_ = new_obj
   self.obj920= AttrCalc()
   self.obj920.Copy=ATOM3Boolean()
   self.obj920.Copy.setValue(('Copy from LHS', 1))
   self.obj920.Copy.config = 0
   self.obj920.Specify=ATOM3Constraint()
   self.obj920.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj92.GGset2Any['tokens']= self.obj920
   self.obj921= AttrCalc()
   self.obj921.Copy=ATOM3Boolean()
   self.obj921.Copy.setValue(('Copy from LHS', 1))
   self.obj921.Copy.config = 0
   self.obj921.Specify=ATOM3Constraint()
   self.obj921.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj92.GGset2Any['name']= self.obj921
   cobj0.RHS.addNode(self.obj92)

   self.obj93=pl2tran(self)

   self.obj93.weight.setNone()
   self.obj93.GGLabel.setValue(5)
   self.obj93.graphClass_= graph_pl2tran
   if self.genGraphics:
      from graph_pl2tran import *
      new_obj = graph_pl2tran(273.5,242.5,self.obj93)
   else: new_obj = None
   self.obj93.graphObject_ = new_obj
   self.obj930= AttrCalc()
   self.obj930.Copy=ATOM3Boolean()
   self.obj930.Copy.setValue(('Copy from LHS', 1))
   self.obj930.Copy.config = 0
   self.obj930.Specify=ATOM3Constraint()
   self.obj930.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj93.GGset2Any['weight']= self.obj930
   cobj0.RHS.addNode(self.obj93)

   self.obj94=PNTransition(self)

   self.obj94.name.setValue('')
   self.obj94.GGLabel.setValue(4)
   self.obj94.graphClass_= graph_PNTransition
   if self.genGraphics:
      from graph_PNTransition import *
      new_obj = graph_PNTransition(281.0,297.0,self.obj94)
   else: new_obj = None
   self.obj94.graphObject_ = new_obj
   self.obj940= AttrCalc()
   self.obj940.Copy=ATOM3Boolean()
   self.obj940.Copy.setValue(('Copy from LHS', 1))
   self.obj940.Copy.config = 0
   self.obj940.Specify=ATOM3Constraint()
   self.obj940.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj94.GGset2Any['name']= self.obj940
   cobj0.RHS.addNode(self.obj94)

   self.obj95=tran2pl(self)

   self.obj95.weight.setValue(1)
   self.obj95.GGLabel.setValue(8)
   self.obj95.graphClass_= graph_tran2pl
   if self.genGraphics:
      from graph_tran2pl import *
      new_obj = graph_tran2pl(313.0,225.0,self.obj95)
   else: new_obj = None
   self.obj95.graphObject_ = new_obj
   self.obj950= AttrCalc()
   self.obj950.Copy=ATOM3Boolean()
   self.obj950.Copy.setValue(('Copy from LHS', 0))
   self.obj950.Copy.config = 0
   self.obj950.Specify=ATOM3Constraint()
   self.obj950.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj95.GGset2Any['weight']= self.obj950
   cobj0.RHS.addNode(self.obj95)

   self.obj96=GenericGraphEdge(self)

   self.obj96.GGLabel.setValue(3)
   self.obj96.graphClass_= graph_GenericGraphEdge
   if self.genGraphics:
      from graph_GenericGraphEdge import *
      new_obj = graph_GenericGraphEdge(183.0,170.0,self.obj96)
   else: new_obj = None
   self.obj96.graphObject_ = new_obj
   cobj0.RHS.addNode(self.obj96)
   self.obj90.out_connections_.append(self.obj89)
   self.obj89.in_connections_.append(self.obj90)
   self.obj90.graphObject_.pendingConnections.append((self.obj90.graphObject_.tag, self.obj89.graphObject_.tag, [183.0, 119.99999999999997, 247.99999999999994, 119.99999999999997], 2, 0))
   self.obj91.out_connections_.append(self.obj93)
   self.obj93.in_connections_.append(self.obj91)
   self.obj91.graphObject_.pendingConnections.append((self.obj91.graphObject_.tag, self.obj93.graphObject_.tag, [201.0, 242.99999999999994, 273.5, 242.49999999999994], 2, 0))
   self.obj91.out_connections_.append(self.obj96)
   self.obj96.in_connections_.append(self.obj91)
   self.obj91.graphObject_.pendingConnections.append((self.obj91.graphObject_.tag, self.obj96.graphObject_.tag, [183.0, 228.99999999999994, 183.0, 170.0], 2, 0))
   self.obj92.out_connections_.append(self.obj90)
   self.obj90.in_connections_.append(self.obj92)
   self.obj92.graphObject_.pendingConnections.append((self.obj92.graphObject_.tag, self.obj90.graphObject_.tag, [297.0, 119.99999999999997, 247.99999999999994, 119.99999999999997], 2, 0))
   self.obj93.out_connections_.append(self.obj94)
   self.obj94.in_connections_.append(self.obj93)
   self.obj93.graphObject_.pendingConnections.append((self.obj93.graphObject_.tag, self.obj94.graphObject_.tag, [314.0, 305.0, 273.5, 242.49999999999994], 2, 0))
   self.obj94.out_connections_.append(self.obj95)
   self.obj95.in_connections_.append(self.obj94)
   self.obj94.graphObject_.pendingConnections.append((self.obj94.graphObject_.tag, self.obj95.graphObject_.tag, [314.0, 305.0, 313.0, 224.99999999999994], 2, 0))
   self.obj95.out_connections_.append(self.obj92)
   self.obj92.in_connections_.append(self.obj95)
   self.obj95.graphObject_.pendingConnections.append((self.obj95.graphObject_.tag, self.obj92.graphObject_.tag, [314.0, 136.0, 313.0, 224.99999999999994], 2, 0))
   self.obj96.out_connections_.append(self.obj89)
   self.obj89.in_connections_.append(self.obj96)
   self.obj96.graphObject_.pendingConnections.append((self.obj96.graphObject_.tag, self.obj89.graphObject_.tag, [183.0, 119.99999999999997, 183.0, 170.0], 2, 0))
   cobj0.Condition=ATOM3Constraint()
   cobj0.Condition.setValue(('condition', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'cap_place = self.getMatched( graphID, self.LHS.nodeWithLabel(6))\nout_trans = self.getMatched( graphID, self.LHS.nodeWithLabel(4))\ncapacity_transition_absent = True\nfor in_link in cap_place.in_connections_:\n for out_link in out_trans.out_connections_:\n  if (in_link == out_link) and isinstance(in_link,tran2pl): \n   capacity_transition_absent = False\n   break\nreturn capacity_transition_absent\n\n\n\n\n'))
   cobj0.Action=ATOM3Constraint()
   cobj0.Action.setValue(('action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
   lcobj0.append(cobj0)
   cobj0= GGruleEdit(None, self)
   cobj0.Name=ATOM3String('CapacityConstraintOnTr2Pl')
   cobj0.Order=ATOM3Integer(7)
   cobj0.TimeDelay=ATOM3Integer(2)
   cobj0.SubtypesMatching=ATOM3Boolean()
   cobj0.SubtypesMatching.setValue((None, 0))
   cobj0.SubtypesMatching.config = 0

   from RoadSection import *
   from ASG_Traffic import *
   from Capacity import *
   from GenericGraphNode import *
   from ASG_PetriNets import *
   from Source2Section import *
   from tran2pl import *
   from CapacityOf import *
   from FlowTo import *
   from PNPlace import *
   from Source import *
   from Sink import *
   from PNTransition import *
   from Section2Sink import *
   from pl2tran import *
   from GenericGraphEdge import *
   from ASG_GenericGraph import *

   cobj0.LHS = ASG_Traffic(self)
   cobj0.LHS.merge(ASG_GenericGraph(self))
   cobj0.LHS.merge(ASG_PetriNets(self))

   self.obj103=RoadSection(self)

   self.obj103.num_vehicles.setNone()
   self.obj103.name.setValue('')
   self.obj103.GGLabel.setValue(1)
   self.obj103.graphClass_= graph_RoadSection
   if self.genGraphics:
      from graph_RoadSection import *
      new_obj = graph_RoadSection(138.0,88.0,self.obj103)
   else: new_obj = None
   self.obj103.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj103)

   self.obj104=CapacityOf(self)

   self.obj104.GGLabel.setValue(7)
   self.obj104.graphClass_= graph_CapacityOf
   if self.genGraphics:
      from graph_CapacityOf import *
      new_obj = graph_CapacityOf(223.0,101.0,self.obj104)
   else: new_obj = None
   self.obj104.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj104)

   self.obj105=GenericGraphEdge(self)

   self.obj105.GGLabel.setValue(3)
   self.obj105.graphClass_= graph_GenericGraphEdge
   if self.genGraphics:
      from graph_GenericGraphEdge import *
      new_obj = graph_GenericGraphEdge(178.0,152.0,self.obj105)
   else: new_obj = None
   self.obj105.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj105)

   self.obj106=PNPlace(self)

   self.obj106.tokens.setNone()
   self.obj106.name.setValue('')
   self.obj106.GGLabel.setValue(2)
   self.obj106.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(154.0,189.0,self.obj106)
   else: new_obj = None
   self.obj106.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj106)

   self.obj107=PNPlace(self)

   self.obj107.tokens.setNone()
   self.obj107.name.setValue('')
   self.obj107.GGLabel.setValue(6)
   self.obj107.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(256.0,84.0,self.obj107)
   else: new_obj = None
   self.obj107.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj107)

   self.obj108=PNTransition(self)

   self.obj108.name.setValue('')
   self.obj108.GGLabel.setValue(4)
   self.obj108.graphClass_= graph_PNTransition
   if self.genGraphics:
      from graph_PNTransition import *
      new_obj = graph_PNTransition(258.0,252.0,self.obj108)
   else: new_obj = None
   self.obj108.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj108)

   self.obj109=tran2pl(self)

   self.obj109.weight.setNone()
   self.obj109.GGLabel.setValue(5)
   self.obj109.graphClass_= graph_tran2pl
   if self.genGraphics:
      from graph_tran2pl import *
      new_obj = graph_tran2pl(256.0,205.5,self.obj109)
   else: new_obj = None
   self.obj109.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj109)
   self.obj104.out_connections_.append(self.obj103)
   self.obj103.in_connections_.append(self.obj104)
   self.obj104.graphObject_.pendingConnections.append((self.obj104.graphObject_.tag, self.obj103.graphObject_.tag, [178.0, 101.0, 222.99999999999994, 100.99999999999991], 2, 0))
   self.obj105.out_connections_.append(self.obj103)
   self.obj103.in_connections_.append(self.obj105)
   self.obj105.graphObject_.pendingConnections.append((self.obj105.graphObject_.tag, self.obj103.graphObject_.tag, [178.0, 101.0, 178.0, 152.0], 2, 0))
   self.obj106.out_connections_.append(self.obj105)
   self.obj105.in_connections_.append(self.obj106)
   self.obj106.graphObject_.pendingConnections.append((self.obj106.graphObject_.tag, self.obj105.graphObject_.tag, [178.0, 192.0, 178.0, 152.0], 2, 0))
   self.obj106.out_connections_.append(self.obj105)
   self.obj105.in_connections_.append(self.obj106)
   self.obj106.graphObject_.pendingConnections.append((self.obj106.graphObject_.tag, self.obj105.graphObject_.tag, [178.0, 192.0, 178.0, 152.0], 2, 0))
   self.obj107.out_connections_.append(self.obj104)
   self.obj104.in_connections_.append(self.obj107)
   self.obj107.graphObject_.pendingConnections.append((self.obj107.graphObject_.tag, self.obj104.graphObject_.tag, [264.0, 100.99999999999993, 222.99999999999994, 100.99999999999991], 2, 0))
   self.obj107.out_connections_.append(self.obj104)
   self.obj104.in_connections_.append(self.obj107)
   self.obj107.graphObject_.pendingConnections.append((self.obj107.graphObject_.tag, self.obj104.graphObject_.tag, [264.0, 100.99999999999993, 222.99999999999994, 100.99999999999991], 2, 0))
   self.obj108.out_connections_.append(self.obj109)
   self.obj109.in_connections_.append(self.obj108)
   self.obj108.graphObject_.pendingConnections.append((self.obj108.graphObject_.tag, self.obj109.graphObject_.tag, [291.0, 259.99999999999994, 255.99999999999994, 205.5], 2, 0))
   self.obj108.out_connections_.append(self.obj109)
   self.obj109.in_connections_.append(self.obj108)
   self.obj108.graphObject_.pendingConnections.append((self.obj108.graphObject_.tag, self.obj109.graphObject_.tag, [291.0, 259.99999999999994, 255.99999999999994, 205.5], 2, 0))
   self.obj109.out_connections_.append(self.obj106)
   self.obj106.in_connections_.append(self.obj109)
   self.obj109.graphObject_.pendingConnections.append((self.obj109.graphObject_.tag, self.obj106.graphObject_.tag, [196.0, 206.0, 255.99999999999994, 205.5], 2, 0))
   self.obj109.out_connections_.append(self.obj106)
   self.obj106.in_connections_.append(self.obj109)
   self.obj109.graphObject_.pendingConnections.append((self.obj109.graphObject_.tag, self.obj106.graphObject_.tag, [196.0, 206.0, 255.99999999999994, 205.5], 2, 0))
   cobj0.RHS = ASG_Traffic(self)
   cobj0.RHS.merge(ASG_GenericGraph(self))
   cobj0.RHS.merge(ASG_PetriNets(self))

   self.obj113=RoadSection(self)

   self.obj113.num_vehicles.setValue(0)
   self.obj113.name.setValue('')
   self.obj113.GGLabel.setValue(1)
   self.obj113.graphClass_= graph_RoadSection
   if self.genGraphics:
      from graph_RoadSection import *
      new_obj = graph_RoadSection(94.0,74.0,self.obj113)
   else: new_obj = None
   self.obj113.graphObject_ = new_obj
   self.obj1130= AttrCalc()
   self.obj1130.Copy=ATOM3Boolean()
   self.obj1130.Copy.setValue(('Copy from LHS', 1))
   self.obj1130.Copy.config = 0
   self.obj1130.Specify=ATOM3Constraint()
   self.obj1130.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj113.GGset2Any['num_vehicles']= self.obj1130
   self.obj1131= AttrCalc()
   self.obj1131.Copy=ATOM3Boolean()
   self.obj1131.Copy.setValue(('Copy from LHS', 1))
   self.obj1131.Copy.config = 0
   self.obj1131.Specify=ATOM3Constraint()
   self.obj1131.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj113.GGset2Any['name']= self.obj1131
   cobj0.RHS.addNode(self.obj113)

   self.obj114=CapacityOf(self)

   self.obj114.GGLabel.setValue(7)
   self.obj114.graphClass_= graph_CapacityOf
   if self.genGraphics:
      from graph_CapacityOf import *
      new_obj = graph_CapacityOf(197.0,87.0,self.obj114)
   else: new_obj = None
   self.obj114.graphObject_ = new_obj
   cobj0.RHS.addNode(self.obj114)

   self.obj115=GenericGraphEdge(self)

   self.obj115.GGLabel.setValue(3)
   self.obj115.graphClass_= graph_GenericGraphEdge
   if self.genGraphics:
      from graph_GenericGraphEdge import *
      new_obj = graph_GenericGraphEdge(134.0,150.0,self.obj115)
   else: new_obj = None
   self.obj115.graphObject_ = new_obj
   cobj0.RHS.addNode(self.obj115)

   self.obj116=PNPlace(self)

   self.obj116.tokens.setValue(0)
   self.obj116.name.setValue('0')
   self.obj116.GGLabel.setValue(2)
   self.obj116.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(110.0,196.0,self.obj116)
   else: new_obj = None
   self.obj116.graphObject_ = new_obj
   self.obj1160= AttrCalc()
   self.obj1160.Copy=ATOM3Boolean()
   self.obj1160.Copy.setValue(('Copy from LHS', 1))
   self.obj1160.Copy.config = 0
   self.obj1160.Specify=ATOM3Constraint()
   self.obj1160.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj116.GGset2Any['tokens']= self.obj1160
   self.obj1161= AttrCalc()
   self.obj1161.Copy=ATOM3Boolean()
   self.obj1161.Copy.setValue(('Copy from LHS', 1))
   self.obj1161.Copy.config = 0
   self.obj1161.Specify=ATOM3Constraint()
   self.obj1161.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj116.GGset2Any['name']= self.obj1161
   cobj0.RHS.addNode(self.obj116)

   self.obj117=PNPlace(self)

   self.obj117.tokens.setValue(0)
   self.obj117.name.setValue('1')
   self.obj117.GGLabel.setValue(6)
   self.obj117.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(240.0,70.0,self.obj117)
   else: new_obj = None
   self.obj117.graphObject_ = new_obj
   self.obj1170= AttrCalc()
   self.obj1170.Copy=ATOM3Boolean()
   self.obj1170.Copy.setValue(('Copy from LHS', 1))
   self.obj1170.Copy.config = 0
   self.obj1170.Specify=ATOM3Constraint()
   self.obj1170.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj117.GGset2Any['tokens']= self.obj1170
   self.obj1171= AttrCalc()
   self.obj1171.Copy=ATOM3Boolean()
   self.obj1171.Copy.setValue(('Copy from LHS', 1))
   self.obj1171.Copy.config = 0
   self.obj1171.Specify=ATOM3Constraint()
   self.obj1171.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj117.GGset2Any['name']= self.obj1171
   cobj0.RHS.addNode(self.obj117)

   self.obj118=pl2tran(self)

   self.obj118.weight.setValue(1)
   self.obj118.GGLabel.setValue(8)
   self.obj118.graphClass_= graph_pl2tran
   if self.genGraphics:
      from graph_pl2tran import *
      new_obj = graph_pl2tran(266.5,188.5,self.obj118)
   else: new_obj = None
   self.obj118.graphObject_ = new_obj
   cobj0.RHS.addNode(self.obj118)

   self.obj119=PNTransition(self)

   self.obj119.name.setValue('0')
   self.obj119.GGLabel.setValue(4)
   self.obj119.graphClass_= graph_PNTransition
   if self.genGraphics:
      from graph_PNTransition import *
      new_obj = graph_PNTransition(233.0,272.0,self.obj119)
   else: new_obj = None
   self.obj119.graphObject_ = new_obj
   self.obj1190= AttrCalc()
   self.obj1190.Copy=ATOM3Boolean()
   self.obj1190.Copy.setValue(('Copy from LHS', 1))
   self.obj1190.Copy.config = 0
   self.obj1190.Specify=ATOM3Constraint()
   self.obj1190.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj119.GGset2Any['name']= self.obj1190
   cobj0.RHS.addNode(self.obj119)

   self.obj120=tran2pl(self)

   self.obj120.weight.setValue(1)
   self.obj120.GGLabel.setValue(5)
   self.obj120.graphClass_= graph_tran2pl
   if self.genGraphics:
      from graph_tran2pl import *
      new_obj = graph_tran2pl(236.5,211.5,self.obj120)
   else: new_obj = None
   self.obj120.graphObject_ = new_obj
   self.obj1200= AttrCalc()
   self.obj1200.Copy=ATOM3Boolean()
   self.obj1200.Copy.setValue(('Copy from LHS', 1))
   self.obj1200.Copy.config = 0
   self.obj1200.Specify=ATOM3Constraint()
   self.obj1200.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj120.GGset2Any['weight']= self.obj1200
   cobj0.RHS.addNode(self.obj120)
   self.obj114.out_connections_.append(self.obj113)
   self.obj113.in_connections_.append(self.obj114)
   self.obj114.graphObject_.pendingConnections.append((self.obj114.graphObject_.tag, self.obj113.graphObject_.tag, [134.0, 87.0, 197.0, 87.0], 2, 0))
   self.obj115.out_connections_.append(self.obj113)
   self.obj113.in_connections_.append(self.obj115)
   self.obj115.graphObject_.pendingConnections.append((self.obj115.graphObject_.tag, self.obj113.graphObject_.tag, [134.0, 87.0, 133.99999999999997, 150.0], 2, 0))
   self.obj116.out_connections_.append(self.obj115)
   self.obj115.in_connections_.append(self.obj116)
   self.obj116.graphObject_.pendingConnections.append((self.obj116.graphObject_.tag, self.obj115.graphObject_.tag, [134.0, 199.0, 133.99999999999997, 150.0], 2, 0))
   self.obj117.out_connections_.append(self.obj114)
   self.obj114.in_connections_.append(self.obj117)
   self.obj117.graphObject_.pendingConnections.append((self.obj117.graphObject_.tag, self.obj114.graphObject_.tag, [247.99999999999994, 87.0, 197.0, 87.0], 2, 0))
   self.obj117.out_connections_.append(self.obj118)
   self.obj118.in_connections_.append(self.obj117)
   self.obj117.graphObject_.pendingConnections.append((self.obj117.graphObject_.tag, self.obj118.graphObject_.tag, [265.0, 102.99999999999997, 266.49999999999994, 188.5], 2, 0))
   self.obj118.out_connections_.append(self.obj119)
   self.obj119.in_connections_.append(self.obj118)
   self.obj118.graphObject_.pendingConnections.append((self.obj118.graphObject_.tag, self.obj119.graphObject_.tag, [266.0, 279.99999999999994, 266.49999999999994, 188.5], 2, 0))
   self.obj119.out_connections_.append(self.obj120)
   self.obj120.in_connections_.append(self.obj119)
   self.obj119.graphObject_.pendingConnections.append((self.obj119.graphObject_.tag, self.obj120.graphObject_.tag, [266.0, 279.99999999999994, 236.49999999999994, 211.5], 2, 0))
   self.obj120.out_connections_.append(self.obj116)
   self.obj116.in_connections_.append(self.obj120)
   self.obj120.graphObject_.pendingConnections.append((self.obj120.graphObject_.tag, self.obj116.graphObject_.tag, [152.0, 212.99999999999994, 236.49999999999994, 211.5], 2, 0))
   cobj0.Condition=ATOM3Constraint()
   cobj0.Condition.setValue(('condition', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'cap_place = self.getMatched( graphID, self.LHS.nodeWithLabel(6))\nin_trans = self.getMatched( graphID, self.LHS.nodeWithLabel(4))\ncapacity_transition_absent = True\nfor out_link in cap_place.out_connections_:\n for in_link in in_trans.in_connections_:\n  if (in_link == out_link) and isinstance(in_link, pl2tran): \n   capacity_transition_absent = False\n   break\nreturn capacity_transition_absent\n\n\n\n\n\n\n\n\n\n'))
   cobj0.Action=ATOM3Constraint()
   cobj0.Action.setValue(('action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
   lcobj0.append(cobj0)
   cobj0= GGruleEdit(None, self)
   cobj0.Name=ATOM3String('InitialCapacity')
   cobj0.Order=ATOM3Integer(8)
   cobj0.TimeDelay=ATOM3Integer(2)
   cobj0.SubtypesMatching=ATOM3Boolean()
   cobj0.SubtypesMatching.setValue((None, 0))
   cobj0.SubtypesMatching.config = 0

   from RoadSection import *
   from ASG_Traffic import *
   from Capacity import *
   from ASG_PetriNets import *
   from Source2Section import *
   from tran2pl import *
   from CapacityOf import *
   from FlowTo import *
   from PNPlace import *
   from Source import *
   from Sink import *
   from Section2Sink import *
   from pl2tran import *
   from PNTransition import *

   cobj0.LHS = ASG_Traffic(self)
   cobj0.LHS.merge(ASG_PetriNets(self))

   self.obj126=RoadSection(self)

   self.obj126.num_vehicles.setNone()
   self.obj126.name.setValue('')
   self.obj126.GGLabel.setValue(1)
   self.obj126.graphClass_= graph_RoadSection
   if self.genGraphics:
      from graph_RoadSection import *
      new_obj = graph_RoadSection(101.0,102.0,self.obj126)
   else: new_obj = None
   self.obj126.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj126)

   self.obj127=CapacityOf(self)

   self.obj127.GGLabel.setValue(3)
   self.obj127.graphClass_= graph_CapacityOf
   if self.genGraphics:
      from graph_CapacityOf import *
      new_obj = graph_CapacityOf(234.0,115.0,self.obj127)
   else: new_obj = None
   self.obj127.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj127)

   self.obj128=PNPlace(self)

   self.obj128.tokens.setNone()
   self.obj128.name.setValue('')
   self.obj128.GGLabel.setValue(2)
   self.obj128.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(305.0,98.0,self.obj128)
   else: new_obj = None
   self.obj128.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj128)
   self.obj127.out_connections_.append(self.obj126)
   self.obj126.in_connections_.append(self.obj127)
   self.obj127.graphObject_.pendingConnections.append((self.obj127.graphObject_.tag, self.obj126.graphObject_.tag, [141.0, 114.99999999999997, 233.99999999999994, 114.99999999999997], 2, 0))
   self.obj128.out_connections_.append(self.obj127)
   self.obj127.in_connections_.append(self.obj128)
   self.obj128.graphObject_.pendingConnections.append((self.obj128.graphObject_.tag, self.obj127.graphObject_.tag, [313.0, 114.99999999999997, 233.99999999999994, 114.99999999999997], 2, 0))
   cobj0.RHS = ASG_Traffic(self)
   cobj0.RHS.merge(ASG_PetriNets(self))

   self.obj131=RoadSection(self)

   self.obj131.num_vehicles.setValue(0)
   self.obj131.name.setValue('')
   self.obj131.GGLabel.setValue(1)
   self.obj131.graphClass_= graph_RoadSection
   if self.genGraphics:
      from graph_RoadSection import *
      new_obj = graph_RoadSection(110.0,125.0,self.obj131)
   else: new_obj = None
   self.obj131.graphObject_ = new_obj
   self.obj1310= AttrCalc()
   self.obj1310.Copy=ATOM3Boolean()
   self.obj1310.Copy.setValue(('Copy from LHS', 1))
   self.obj1310.Copy.config = 0
   self.obj1310.Specify=ATOM3Constraint()
   self.obj1310.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj131.GGset2Any['num_vehicles']= self.obj1310
   self.obj1311= AttrCalc()
   self.obj1311.Copy=ATOM3Boolean()
   self.obj1311.Copy.setValue(('Copy from LHS', 1))
   self.obj1311.Copy.config = 0
   self.obj1311.Specify=ATOM3Constraint()
   self.obj1311.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj131.GGset2Any['name']= self.obj1311
   cobj0.RHS.addNode(self.obj131)

   self.obj132=PNPlace(self)

   self.obj132.tokens.setValue(0)
   self.obj132.name.setValue('0')
   self.obj132.GGLabel.setValue(2)
   self.obj132.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(309.0,115.0,self.obj132)
   else: new_obj = None
   self.obj132.graphObject_ = new_obj
   self.obj1320= AttrCalc()
   self.obj1320.Copy=ATOM3Boolean()
   self.obj1320.Copy.setValue(('Copy from LHS', 0))
   self.obj1320.Copy.config = 0
   self.obj1320.Specify=ATOM3Constraint()
   self.obj1320.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'initial_num_vehicles = self.getMatched(graphID, self.LHS.nodeWithLabel(1)).num_vehicles.getValue()\ncapacity_tokens = self.getMatched(graphID, self.LHS.nodeWithLabel(2)).tokens.getValue()\nreturn capacity_tokens-initial_num_vehicles\n\n\n\n\n\n\n'))
   self.obj132.GGset2Any['tokens']= self.obj1320
   self.obj1321= AttrCalc()
   self.obj1321.Copy=ATOM3Boolean()
   self.obj1321.Copy.setValue(('Copy from LHS', 1))
   self.obj1321.Copy.config = 0
   self.obj1321.Specify=ATOM3Constraint()
   self.obj1321.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj132.GGset2Any['name']= self.obj1321
   cobj0.RHS.addNode(self.obj132)
   cobj0.Condition=ATOM3Constraint()
   cobj0.Condition.setValue(('condition', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# note that the number of capacity tokens should never become <= 0\nreturn 1\n\n'))
   cobj0.Action=ATOM3Constraint()
   cobj0.Action.setValue(('action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
   lcobj0.append(cobj0)
   cobj0= GGruleEdit(None, self)
   cobj0.Name=ATOM3String('RemoveRoadSection')
   cobj0.Order=ATOM3Integer(9)
   cobj0.TimeDelay=ATOM3Integer(2)
   cobj0.SubtypesMatching=ATOM3Boolean()
   cobj0.SubtypesMatching.setValue((None, 0))
   cobj0.SubtypesMatching.config = 0

   from RoadSection import *
   from ASG_Traffic import *
   from Capacity import *
   from GenericGraphNode import *
   from Source2Section import *
   from CapacityOf import *
   from FlowTo import *
   from Source import *
   from Sink import *
   from Section2Sink import *
   from GenericGraphEdge import *
   from ASG_GenericGraph import *

   cobj0.LHS = ASG_Traffic(self)
   cobj0.LHS.merge(ASG_GenericGraph(self))

   self.obj138=RoadSection(self)

   self.obj138.num_vehicles.setNone()
   self.obj138.name.setValue('')
   self.obj138.GGLabel.setValue(1)
   self.obj138.graphClass_= graph_RoadSection
   if self.genGraphics:
      from graph_RoadSection import *
      new_obj = graph_RoadSection(132.0,117.0,self.obj138)
   else: new_obj = None
   self.obj138.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj138)

   self.obj139=GenericGraphEdge(self)

   self.obj139.GGLabel.setValue(2)
   self.obj139.graphClass_= graph_GenericGraphEdge
   if self.genGraphics:
      from graph_GenericGraphEdge import *
      new_obj = graph_GenericGraphEdge(153.0,198.0,self.obj139)
   else: new_obj = None
   self.obj139.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj139)
   self.obj139.out_connections_.append(self.obj138)
   self.obj138.in_connections_.append(self.obj139)
   self.obj139.graphObject_.pendingConnections.append((self.obj139.graphObject_.tag, self.obj138.graphObject_.tag, [172.0, 130.0, 153.0, 198.0], 2, 0))
   cobj0.RHS = ASG_Traffic(self)
   cobj0.Condition=ATOM3Constraint()
   cobj0.Condition.setValue(('condition', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'return 1\n'))
   cobj0.Action=ATOM3Constraint()
   cobj0.Action.setValue(('action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
   lcobj0.append(cobj0)
   cobj0= GGruleEdit(None, self)
   cobj0.Name=ATOM3String('Capacity2PNPlaceLinks')
   cobj0.Order=ATOM3Integer(4)
   cobj0.TimeDelay=ATOM3Integer(2)
   cobj0.SubtypesMatching=ATOM3Boolean()
   cobj0.SubtypesMatching.setValue((None, 0))
   cobj0.SubtypesMatching.config = 0

   from RoadSection import *
   from ASG_Traffic import *
   from Capacity import *
   from GenericGraphNode import *
   from ASG_PetriNets import *
   from Source2Section import *
   from tran2pl import *
   from CapacityOf import *
   from FlowTo import *
   from PNPlace import *
   from Source import *
   from Sink import *
   from ASG_GenericGraph import *
   from Section2Sink import *
   from pl2tran import *
   from GenericGraphEdge import *
   from PNTransition import *

   cobj0.LHS = ASG_Traffic(self)
   cobj0.LHS.merge(ASG_PetriNets(self))
   cobj0.LHS.merge(ASG_GenericGraph(self))

   self.obj147=RoadSection(self)

   self.obj147.num_vehicles.setNone()
   self.obj147.name.setValue('')
   self.obj147.GGLabel.setValue(4)
   self.obj147.graphClass_= graph_RoadSection
   if self.genGraphics:
      from graph_RoadSection import *
      new_obj = graph_RoadSection(120.0,48.0,self.obj147)
   else: new_obj = None
   self.obj147.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj147)

   self.obj148=Capacity(self)

   self.obj148.capacity.setNone()
   self.obj148.name.setValue('')
   self.obj148.GGLabel.setValue(1)
   self.obj148.graphClass_= graph_Capacity
   if self.genGraphics:
      from graph_Capacity import *
      new_obj = graph_Capacity(100.0,149.0,self.obj148)
   else: new_obj = None
   self.obj148.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj148)

   self.obj149=CapacityOf(self)

   self.obj149.GGLabel.setValue(5)
   self.obj149.graphClass_= graph_CapacityOf
   if self.genGraphics:
      from graph_CapacityOf import *
      new_obj = graph_CapacityOf(133.0,111.5,self.obj149)
   else: new_obj = None
   self.obj149.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj149)

   self.obj150=PNPlace(self)

   self.obj150.tokens.setNone()
   self.obj150.name.setValue('')
   self.obj150.GGLabel.setValue(2)
   self.obj150.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(282.0,143.0,self.obj150)
   else: new_obj = None
   self.obj150.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj150)

   self.obj151=GenericGraphEdge(self)

   self.obj151.GGLabel.setValue(3)
   self.obj151.graphClass_= graph_GenericGraphEdge
   if self.genGraphics:
      from graph_GenericGraphEdge import *
      new_obj = graph_GenericGraphEdge(221.0,160.0,self.obj151)
   else: new_obj = None
   self.obj151.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj151)
   self.obj148.out_connections_.append(self.obj149)
   self.obj149.in_connections_.append(self.obj148)
   self.obj148.graphObject_.pendingConnections.append((self.obj148.graphObject_.tag, self.obj149.graphObject_.tag, [132.99999999999997, 160.0, 133.0, 111.49999999999997], 2, 0))
   self.obj149.out_connections_.append(self.obj147)
   self.obj147.in_connections_.append(self.obj149)
   self.obj149.graphObject_.pendingConnections.append((self.obj149.graphObject_.tag, self.obj147.graphObject_.tag, [160.0, 60.999999999999986, 133.0, 111.49999999999997], 2, 0))
   self.obj150.out_connections_.append(self.obj151)
   self.obj151.in_connections_.append(self.obj150)
   self.obj150.graphObject_.pendingConnections.append((self.obj150.graphObject_.tag, self.obj151.graphObject_.tag, [290.0, 160.0, 220.99999999999994, 160.0], 2, 0))
   self.obj151.out_connections_.append(self.obj148)
   self.obj148.in_connections_.append(self.obj151)
   self.obj151.graphObject_.pendingConnections.append((self.obj151.graphObject_.tag, self.obj148.graphObject_.tag, [132.99999999999997, 160.0, 220.99999999999994, 160.0], 2, 0))
   cobj0.RHS = ASG_Traffic(self)
   cobj0.RHS.merge(ASG_PetriNets(self))
   cobj0.RHS.merge(ASG_GenericGraph(self))

   self.obj155=RoadSection(self)

   self.obj155.num_vehicles.setValue(0)
   self.obj155.name.setValue('')
   self.obj155.GGLabel.setValue(4)
   self.obj155.graphClass_= graph_RoadSection
   if self.genGraphics:
      from graph_RoadSection import *
      new_obj = graph_RoadSection(180.0,100.0,self.obj155)
   else: new_obj = None
   self.obj155.graphObject_ = new_obj
   self.obj1550= AttrCalc()
   self.obj1550.Copy=ATOM3Boolean()
   self.obj1550.Copy.setValue(('Copy from LHS', 1))
   self.obj1550.Copy.config = 0
   self.obj1550.Specify=ATOM3Constraint()
   self.obj1550.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj155.GGset2Any['num_vehicles']= self.obj1550
   self.obj1551= AttrCalc()
   self.obj1551.Copy=ATOM3Boolean()
   self.obj1551.Copy.setValue(('Copy from LHS', 1))
   self.obj1551.Copy.config = 0
   self.obj1551.Specify=ATOM3Constraint()
   self.obj1551.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj155.GGset2Any['name']= self.obj1551
   cobj0.RHS.addNode(self.obj155)

   self.obj156=Capacity(self)

   self.obj156.capacity.setValue(0)
   self.obj156.name.setValue('')
   self.obj156.GGLabel.setValue(1)
   self.obj156.graphClass_= graph_Capacity
   if self.genGraphics:
      from graph_Capacity import *
      new_obj = graph_Capacity(185.0,203.0,self.obj156)
   else: new_obj = None
   self.obj156.graphObject_ = new_obj
   self.obj1560= AttrCalc()
   self.obj1560.Copy=ATOM3Boolean()
   self.obj1560.Copy.setValue(('Copy from LHS', 1))
   self.obj1560.Copy.config = 0
   self.obj1560.Specify=ATOM3Constraint()
   self.obj1560.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj156.GGset2Any['capacity']= self.obj1560
   self.obj1561= AttrCalc()
   self.obj1561.Copy=ATOM3Boolean()
   self.obj1561.Copy.setValue(('Copy from LHS', 1))
   self.obj1561.Copy.config = 0
   self.obj1561.Specify=ATOM3Constraint()
   self.obj1561.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj156.GGset2Any['name']= self.obj1561
   cobj0.RHS.addNode(self.obj156)

   self.obj157=CapacityOf(self)

   self.obj157.GGLabel.setValue(6)
   self.obj157.graphClass_= graph_CapacityOf
   if self.genGraphics:
      from graph_CapacityOf import *
      new_obj = graph_CapacityOf(340.0,113.0,self.obj157)
   else: new_obj = None
   self.obj157.graphObject_ = new_obj
   cobj0.RHS.addNode(self.obj157)

   self.obj158=PNPlace(self)

   self.obj158.tokens.setValue(0)
   self.obj158.name.setValue('0')
   self.obj158.GGLabel.setValue(2)
   self.obj158.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(358.0,197.0,self.obj158)
   else: new_obj = None
   self.obj158.graphObject_ = new_obj
   self.obj1580= AttrCalc()
   self.obj1580.Copy=ATOM3Boolean()
   self.obj1580.Copy.setValue(('Copy from LHS', 1))
   self.obj1580.Copy.config = 0
   self.obj1580.Specify=ATOM3Constraint()
   self.obj1580.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj158.GGset2Any['tokens']= self.obj1580
   self.obj1581= AttrCalc()
   self.obj1581.Copy=ATOM3Boolean()
   self.obj1581.Copy.setValue(('Copy from LHS', 1))
   self.obj1581.Copy.config = 0
   self.obj1581.Specify=ATOM3Constraint()
   self.obj1581.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj158.GGset2Any['name']= self.obj1581
   cobj0.RHS.addNode(self.obj158)

   self.obj159=GenericGraphEdge(self)

   self.obj159.GGLabel.setValue(3)
   self.obj159.graphClass_= graph_GenericGraphEdge
   if self.genGraphics:
      from graph_GenericGraphEdge import *
      new_obj = graph_GenericGraphEdge(298.0,214.0,self.obj159)
   else: new_obj = None
   self.obj159.graphObject_ = new_obj
   cobj0.RHS.addNode(self.obj159)
   self.obj157.out_connections_.append(self.obj155)
   self.obj155.in_connections_.append(self.obj157)
   self.obj157.graphObject_.pendingConnections.append((self.obj157.graphObject_.tag, self.obj155.graphObject_.tag, [219.99999999999994, 112.99999999999997, 340.0, 112.99999999999997], 2, 0))
   self.obj158.out_connections_.append(self.obj159)
   self.obj159.in_connections_.append(self.obj158)
   self.obj158.graphObject_.pendingConnections.append((self.obj158.graphObject_.tag, self.obj159.graphObject_.tag, [366.0, 213.99999999999994, 298.0, 213.99999999999994], 2, 0))
   self.obj158.out_connections_.append(self.obj157)
   self.obj157.in_connections_.append(self.obj158)
   self.obj158.graphObject_.pendingConnections.append((self.obj158.graphObject_.tag, self.obj157.graphObject_.tag, [382.0, 200.0, 340.0, 112.99999999999997], 2, 0))
   self.obj159.out_connections_.append(self.obj156)
   self.obj156.in_connections_.append(self.obj159)
   self.obj159.graphObject_.pendingConnections.append((self.obj159.graphObject_.tag, self.obj156.graphObject_.tag, [217.99999999999994, 214.0, 298.0, 213.99999999999994], 2, 0))
   cobj0.Condition=ATOM3Constraint()
   cobj0.Condition.setValue(('condition', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'return 1\n'))
   cobj0.Action=ATOM3Constraint()
   cobj0.Action.setValue(('action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
   lcobj0.append(cobj0)
   cobj0= GGruleEdit(None, self)
   cobj0.Name=ATOM3String('Capacity2PNPlaceCleanup')
   cobj0.Order=ATOM3Integer(5)
   cobj0.TimeDelay=ATOM3Integer(2)
   cobj0.SubtypesMatching=ATOM3Boolean()
   cobj0.SubtypesMatching.setValue((None, 0))
   cobj0.SubtypesMatching.config = 0

   from RoadSection import *
   from ASG_Traffic import *
   from Capacity import *
   from GenericGraphNode import *
   from ASG_PetriNets import *
   from Source2Section import *
   from tran2pl import *
   from CapacityOf import *
   from FlowTo import *
   from PNPlace import *
   from Source import *
   from Sink import *
   from ASG_GenericGraph import *
   from Section2Sink import *
   from pl2tran import *
   from GenericGraphEdge import *
   from PNTransition import *

   cobj0.LHS = ASG_Traffic(self)
   cobj0.LHS.merge(ASG_PetriNets(self))
   cobj0.LHS.merge(ASG_GenericGraph(self))

   self.obj166=Capacity(self)

   self.obj166.capacity.setNone()
   self.obj166.name.setValue('')
   self.obj166.GGLabel.setValue(1)
   self.obj166.graphClass_= graph_Capacity
   if self.genGraphics:
      from graph_Capacity import *
      new_obj = graph_Capacity(155.0,176.0,self.obj166)
   else: new_obj = None
   self.obj166.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj166)

   self.obj167=PNPlace(self)

   self.obj167.tokens.setNone()
   self.obj167.name.setValue('')
   self.obj167.GGLabel.setValue(2)
   self.obj167.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(336.0,170.0,self.obj167)
   else: new_obj = None
   self.obj167.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj167)

   self.obj168=GenericGraphEdge(self)

   self.obj168.GGLabel.setValue(3)
   self.obj168.graphClass_= graph_GenericGraphEdge
   if self.genGraphics:
      from graph_GenericGraphEdge import *
      new_obj = graph_GenericGraphEdge(272.0,187.0,self.obj168)
   else: new_obj = None
   self.obj168.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj168)
   self.obj167.out_connections_.append(self.obj168)
   self.obj168.in_connections_.append(self.obj167)
   self.obj167.graphObject_.pendingConnections.append((self.obj167.graphObject_.tag, self.obj168.graphObject_.tag, [344.0, 187.0, 272.0, 187.0], 2, 0))
   self.obj168.out_connections_.append(self.obj166)
   self.obj166.in_connections_.append(self.obj168)
   self.obj168.graphObject_.pendingConnections.append((self.obj168.graphObject_.tag, self.obj166.graphObject_.tag, [187.99999999999997, 187.0, 272.0, 187.0], 2, 0))
   cobj0.RHS = ASG_PetriNets(self)

   self.obj170=PNPlace(self)

   self.obj170.tokens.setValue(0)
   self.obj170.name.setValue('0')
   self.obj170.GGLabel.setValue(2)
   self.obj170.graphClass_= graph_PNPlace
   if self.genGraphics:
      from graph_PNPlace import *
      new_obj = graph_PNPlace(114.0,94.0,self.obj170)
   else: new_obj = None
   self.obj170.graphObject_ = new_obj
   self.obj1700= AttrCalc()
   self.obj1700.Copy=ATOM3Boolean()
   self.obj1700.Copy.setValue(('Copy from LHS', 1))
   self.obj1700.Copy.config = 0
   self.obj1700.Specify=ATOM3Constraint()
   self.obj1700.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj170.GGset2Any['tokens']= self.obj1700
   self.obj1701= AttrCalc()
   self.obj1701.Copy=ATOM3Boolean()
   self.obj1701.Copy.setValue(('Copy from LHS', 1))
   self.obj1701.Copy.config = 0
   self.obj1701.Specify=ATOM3Constraint()
   self.obj1701.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '\n'))
   self.obj170.GGset2Any['name']= self.obj1701
   cobj0.RHS.addNode(self.obj170)
   cobj0.Condition=ATOM3Constraint()
   cobj0.Condition.setValue(('condition', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'return 1\n'))
   cobj0.Action=ATOM3Constraint()
   cobj0.Action.setValue(('action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
   lcobj0.append(cobj0)
   self.EditingGraphGrammar.Rules.setValue(lcobj0)
   self.EditingGraphGrammar.InitialAction=ATOM3Constraint()
   self.EditingGraphGrammar.InitialAction.setValue(('constraint', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'for node in graph.listNodes["RoadSection"]:\n node.vehiclesPNPlaceGenerated=False\n\n\n\n\n\n\n\n\n\n\n\n\n'))
   self.EditingGraphGrammar.FinalAction=ATOM3Constraint()
   self.EditingGraphGrammar.FinalAction.setValue(('const', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))


